;-------------------------------------------------------------------------;
.include "bg_scrolltext.inc"
.include "snes.inc"
;-------------------------------------------------------------------------;
.importzp shadow_hdmaen
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.bss
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
base_vram_addr:
	.res 2
scrollcolumn:
	.res 2
scrollcount:
	.res 2
;scrollstorage1:
;	.res 2
;scrollstorage2:
;	.res 2
scrolltext:
	.res 2
scrollval:
	.res 2
scrollypos:
	.res 2
sineoffset:
	.res 2
xstorage:
	.res 2
;xstorage1:
;	.res 2
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
RAM_BG2HOFS	=	04e7h	; 39h/57 bytes
RAM_VSINE	=	7f0000h	;
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.zeropage
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
text_ptr:
	.res 3
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


;=========================================================================;
;       Code (c) 1995 -Pan-/ANTHROX   All code can be used at will!
;=========================================================================;                     
; modified by Augustus Blackheart - not all changes were documented see
; original source at dist/SOURC~11.TXT

	.a8
	.i16


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
; A = Text bank
; B = Scrolltext YPOS (0-15)
; X = Text address
; Y = BG VRAM address
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
SetupBGScrollText:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	sta	text_ptr+2
	stx	text_ptr
	sty	base_vram_addr
	;sty	scrollstorage1
	;sty	scrollstorage2

	ldx	#0000h
	stx	scrolltext
	stx	sineoffset

	xba			; get scrolltext Y position

	rep	#30h

	and	#%1111		; do not exceed 0fh

	asl a			; *2
	asl a			; *4
	asl a			; *8

	pha			; number of hdma lines for bg2hofs

	asl a			; *16
	asl a			; *32

	sta	scrollypos	; number of vram chars for scrolltext ypos

	pla

	sep	#20h

	sec
	sbc	#04h
	sta	RAM_BG2HOFS
	stz	RAM_BG2HOFS+1
	sta	RAM_BG2HOFS+2

	ldx	#0003h
	lda	#01h
:	sta	RAM_BG2HOFS,x
	inx
	stz	RAM_BG2HOFS,x
	inx
	sta	RAM_BG2HOFS,x
	inx
	cpx	#0011h*3
	bne	:-

	stz	RAM_BG2HOFS,x
	stz	RAM_BG2HOFS+1,x
	stz	RAM_BG2HOFS+2,x

	lda     #DMAP_XFER_MODE_2
	sta	REG_DMAP4

	lda     #<REG_BG2HOFS
	sta     REG_BBAD4         
	ldx     #RAM_BG2HOFS
	stx     REG_A1T4L
	stz     REG_A1B4

	lda	#%10000
	sta	shadow_hdmaen

	phb

	rep	#30h

	lda	#008fh
	sta	scrollcolumn
	ina
	sta	scrollval
	lsr
	sta	scrollcount		; we're cutting scrollcount in half

	lda	#VSINE_END-VSINE	; copy VSINE twice
	pha
	ldx	#VSINE
	phx
	ldy	#RAM_VSINE

	mvn	^RAM_VSINE,^VSINE
	;	^^-- DBR = ^RAM_VSINE now

	plx
	pla
	ldy	#RAM_VSINE+(VSINE_END-VSINE)
	mvn	^RAM_VSINE,^VSINE

	sep	#20h

	plb

_exit:	rts


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
;                              Scroll Routine
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
BGScrollText:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	;rep	#10h			; modifications to use pointer for
	;sep	#20h			; scrolltext and save bytes/cycles

	;ldy	scrollval
	;iny
	;iny
	;sty	scrollval

	rep	#30h

	inc	scrollval
	inc	scrollval

	sep	#20h

	dec	scrollcount
	;dec	scrollcount		; lose this decrease since we've halved
	lda	scrollcount		; scrollcount and initial scrollcount
	bne	_exit			; value is 48h instead of 90h
;-------------------------------------------------------------------------;
ScrollOk:
;-------------------------------------------------------------------------;
	lda	#08h			; 1 dec = 08h (original was 10h)
	sta	scrollcount

	lda	scrollcolumn
	inc a				; increase scroll column
	and	#1fh
	sta	scrollcolumn

	rep	#30h

	;lda	scrollcolumn		; already loaded above
	and	#000fh
	asl a
	clc
	adc	base_vram_addr
	adc	scrollypos
	pha
	;sta	scrollstorage1		; get push-y instead

	lda	scrollcolumn
	and	#0010h
	bne	Eq400
;-------------------------------------------------------------------------;
	;lda	scrollstorage1	
	pla
	bra	Not400
;-------------------------------------------------------------------------;
Eq400:
;-------------------------------------------------------------------------;
	;lda	scrollstorage1
	pla
	clc
	adc	#0400h
;-------------------------------------------------------------------------;
Not400:	tax				; the address
;-------------------------------------------------------------------------;
	ldy	scrolltext
:	lda	[text_ptr],y
	and	#00ffh
	bne	NoResetScroll
;-------------------------------------------------------------------------;
	ldy	#0000h
	sty	scrolltext
	bra	:-
;-------------------------------------------------------------------------;
NoResetScroll:
;-------------------------------------------------------------------------;
	cmp	#005fh
	bcc	AllCaps
;-------------------------------------------------------------------------;
	;sec				; instruction not needed here
	sbc	#0020h
;-------------------------------------------------------------------------;
AllCaps:
;-------------------------------------------------------------------------;
	sec
	sbc	#0020h
	asl a
	;ora	#0c00h			; #xxyy xx = palette

	;ldx	scrollstorage2		; value we need is already in x
	stx	REG_VMADDL		; top row address

	sta	REG_VMDATAL		; upper left
	pha
	inc a
	sta	REG_VMDATAL		; upper right
	;dec a				; no need for dec by doing pha earlier
	;pha				; save a byte by doing pha prior to inc

	;ldx	scrollstorage2		; value we need is already in x
	txa
	clc
	adc	#0020h
	;tax
	;stx	scrollstorage2
	sta	REG_VMADDL		; bottom row

	pla
	clc
	adc	#0080h
	sta	REG_VMDATAL		; lower left
	inc a
	sta	REG_VMDATAL		; lower right

	inc	scrolltext
	
	sep	#20h

	;ldy	scrolltext
	;iny
	;sty	scrolltext
	rts


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
;                      Plane 1 HDMA swing left/right
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
BGScrollSquish:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	inc	sineoffset		; increase sine offset ($00 - $ff)

	rep	#30h

	;ldx	#0010h
	;stx	xstorage1		; unnecessary using cpy
	
	ldy	#0000h
	
	lda	sineoffset
	sta	xstorage		; xstorage2 has become xstorage
	;asl a
	;tax
;-------------------------------------------------------------------------;
HDMASwish:
;-------------------------------------------------------------------------;
	iny			 
	
	lda	xstorage
	asl a
	tax

	lda	RAM_VSINE,x
	clc
	adc	scrollval
			 
	sta	RAM_BG2HOFS+3,y
	
	inc	xstorage

	iny	 
	iny
	;dec	xstorage1
	cpy	#0010h*3
	bne	HDMASwish
;-------------------------------------------------------------------------;
	sep	#20h
	rts


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
VSINE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
 .word	108,109,111,112,113,114,115,115,116,117,118,119,120,120,121,122
 .word	122,123,123,124,124,125,125,125,126,126,126,127,127,127,127,127
 .word	127,127,127,127,127,127,126,126,126,125,125,125,124,124,123,123
 .word	122,122,121,120,120,119,118,117,116,115,115,114,113,112,111,109
 .word	108,107,106,105,104,103,101,100,099,097,096,095,093,092,091,089
 .word	088,086,085,083,082,080,079,077,076,074,073,071,070,068,067,065
 .word	064,062,060,059,057,056,054,053,051,050,048,047,045,044,042,041
 .word	039,038,036,035,034,032,031,030,028,027,026,024,023,022,021,020
 .word	019,018,016,015,014,013,012,012,011,010,009,008,007,007,006,005
 .word	005,004,004,003,003,002,002,002,001,001,001,000,000,000,000,000
 .word	000,000,000,000,000,000,001,001,001,002,002,002,003,003,004,004
 .word	005,005,006,007,007,008,009,010,011,012,012,013,014,015,016,018
 .word	019,020,021,022,023,024,026,027,028,030,031,032,034,035,036,038
 .word	039,041,042,044,045,047,048,050,051,053,054,056,057,059,060,062
 .word	064,065,067,068,070,071,073,074,076,077,079,080,082,083,085,086
 .word	088,089,091,092,093,095,096,097,099,100,101,103,104,105,106,107
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
VSINE_END:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
