;-------------------------------------------------------------------------;
.include "snes.inc"
.include "snes_joypad.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;
.export DoParallax
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


	.a8
	.i16


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
DoParallax:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;


	rep	#10h
	sep	#20h

	lda	#8fh
	sta	REG_INIDISP
	lda	#BGMODE_7
	sta	REG_BGMODE

	stz	REG_BG1SC
	stz	REG_BG12NBA

	lda	#0dch
	sta	REG_BG1HOFS
	xba
	lda	#0ffh
	sta	REG_BG1HOFS
	xba
	sta	REG_BG1VOFS
	xba
	sta	REG_BG1VOFS

	lda	#TM_BG1
	sta	REG_TM
	lda	#INI_OVERSCAN
	sta	REG_SETINI

	stz	REG_M7SEL
	stz	REG_VMAIN
	stz	REG_CGADD

	ldx	#0000h
	txy
;-------------------------------------------------------------------------;
cppal:	lda	PALETTE,x
	sta	REG_CGDATA
	inx
	cpx	#0040h
	bne	cppal
;-------------------------------------------------------------------------;
	stz	REG_VMADDL
	stz	REG_VMADDH
	stz	REG_VMAIN
;-------------------------------------------------------------------------;
resx:	ldx	#0000h
;-------------------------------------------------------------------------;
cpmap:	lda	M7MAP,x
	sta	REG_VMDATAL
	inx
	cpx	#0080h
	bne	cpmap
	iny
	cpy	#0040h
	bne	resx
;-------------------------------------------------------------------------;
	jsr	Mode7Chr

	stz	REG_HDMAEN
	stz	REG_DMAP0
	stz	REG_BBAD0		; REG_INIDISP
	ldx	#.loword(LIST_INIDISP)
	stx	REG_A1T0L
	lda	#^LIST_INIDISP
	sta	REG_A1B0
	lda	#%1
	sta	REG_HDMAEN

	lda	#NMI_IRQY|NMI_JOYPAD
	sta	REG_NMITIMEN

	lda	#0d3h
	sta	REG_VTIMEL
	stz	REG_VTIMEH

	ldx	#00b4h
	stx	m6

	ldx	#0000h
	stx	m5

	lda	#0fh
	sta	REG_INIDISP
;=========================================================================;
Loop:
;=========================================================================;
	lda	REG_TIMEUP
	and	#80h
	beq	Loop
;-------------------------------------------------------------------------;
	jsr	JoypadStuff
	ldx	m6
	inx
	inx
	cpx	#02d0h
	bne	no_reset_1042
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
no_reset_1042:
;-------------------------------------------------------------------------;
	stx	m6

	lda	PSINE+79h,x
	sta	REG_M7A
	lda	PSINE+78h,x
	sta	REG_M7A
	lda	PSINE+79h,x
	sta	REG_M7D
	lda	PSINE+78h,x
	sta	REG_M7D

	lda	PSINE+01h,x
	sta	REG_M7B
	sta	m7+1
	lda	PSINE,x
	sta	REG_M7B
	sta	m7

	lda	#00h
	clc
	sbc	m7+1
	sta	REG_M7C
	lda	#00h
	sbc	m7
	sta	REG_M7C

	lda	#58h
	sta	REG_M7X
	stz	REG_M7X
	sta	REG_M7Y
	stz	REG_M7Y
;-------------------------------------------------------------------------;
	lda	REG_RDNMI
	jsr	Mode7Chr
	bra	Loop

;=========================================================================;
JoypadStuff:
;=========================================================================;
	lda	REG_HVBJOY
	and	#10h
	bne	JoypadStuff
;-------------------------------------------------------------------------;
	lda	REG_JOY1L
	bit	#JOYPAD_A
	bne	:+
	bit	#JOYPAD_X
	bne	:+
	lda	REG_JOY1H
	bit	#JOYPADH_B
	bne	:+
	bit	#JOYPADH_Y
	bne	:+
;-------------------------------------------------------------------------;
:	rts
;-------------------------------------------------------------------------;

;=========================================================================;
Mode7Chr:
;=========================================================================;
	stz	REG_VMADDL
	stz	REG_VMADDH

	lda	#80h
	sta	REG_VMAIN

	ldx	m5
	ldy	#0000h

	rep	#20h

	txa
	adc	#00b0h
	cmp	#2c00h
	bne	:+
;-------------------------------------------------------------------------;
	tya
;-------------------------------------------------------------------------;
:	tax
;-------------------------------------------------------------------------;
	sep	#20h

	stx	m5
;-------------------------------------------------------------------------;
copy_m7chr:
;-------------------------------------------------------------------------;
	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	lda	M7CHR,x
	sta	REG_VMDATAH
	lda	M7CHR+01h,x
	sta	REG_VMDATAH
	lda	M7CHR+02h,x
	sta	REG_VMDATAH
	lda	M7CHR+03h,x
	sta	REG_VMDATAH
	lda	M7CHR+04h,x
	sta	REG_VMDATAH
	lda	M7CHR+05h,x
	sta	REG_VMDATAH
	lda	M7CHR+06h,x
	sta	REG_VMDATAH
	lda	M7CHR+07h,x
	sta	REG_VMDATAH

	inx
	inx
	inx
	inx
	inx
	inx
	inx
	inx
	iny
	cpy	#0016h
	bne	:+
;-------------------------------------------------------------------------;
	rts
;-------------------------------------------------------------------------;
:	jmp	copy_m7chr


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
PALETTE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	1c00h,1c01h,1c02h,1c03h,1c04h,1c05h,1c06h,1c07h
	.word	1c08h,1c09h,1c0ah,1c0bh,1c0ch,1c0dh,1c0eh,1c0fh
	.word	1c10h,1c11h,1c12h,1c13h,1c14h,1c15h,1c16h,1c17h
	.word	1c18h,1c19h,1c1ah,1c1bh,1c1ch,1c1dh,1c1eh,1c1fh
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
M7MAP:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$01,$02,$03,$04,$05,$06,$07,$08
	.byte	$09,$0a,$0b,$0c,$0d,$0e,$0f,$10
	.byte	$11,$12,$13,$14,$15,$16,$ff,$a0
	.byte	$ff,$a1,$ff,$a1,$ff,$a1,$ff,$a1
	.byte	$ff,$a1,$ff,$a1,$ff,$a1,$ff,$a1
	.byte	$ff,$a2,$ff,$a2,$ff,$a2,$ff,$a3
	.byte	$ff,$a3,$ff,$a3,$ff,$a4,$ff,$a4
	.byte	$ff,$a5,$ff,$a5,$ff,$a6,$ff,$a6
	.byte	$ff,$a7,$ff,$a7,$ff,$a8,$ff,$a9
	.byte	$ff,$a9,$ff,$aa,$ff,$ab,$ff,$ac
	.byte	$ff,$ad,$ff,$ad,$ff,$ae,$ff,$af
	.byte	$ff,$b0,$ff,$b1,$ff,$b2,$ff,$b3
	.byte	$ff,$b4,$ff,$b5,$ff,$b6,$ff,$b7
	.byte	$ff,$b8,$ff,$b9,$ff,$ba,$ff,$bb
	.byte	$ff,$bd,$ff,$be,$ff,$bf,$ff,$c0
	.byte	$ff,$c2,$ff,$c3,$ff,$c4,$ff,$c5
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_INIDISP:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$f8,$80,$80,$80,$80,$80,$80,$80
	.byte	$80,$80,$80,$80,$80,$80,$80,$80
	.byte	$80,$80,$80,$80,$80,$80,$80,$80
	.byte	$80,$80,$80,$80,$80,$80,$03,$08
	.byte	$0b,$0d,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$f8,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	.byte	$0f,$0f,$0f,$0d,$0b,$08,$03,$8f
	.byte	$8f,$8f,$8f,$8f,$8f,$8f,$8f,$8f
	.byte	$8f,$8f,$8f,$8f,$8f,$8f,$8f,$8f
	.byte	$8f,$8f,$8f,$8f,$8f,$8f,$8f,$8f
	.byte	$8f,$8f,$8f,$8f,$8f,$8f,$00
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
PSINE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$a0ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff
	.word	$a1ff,$a2ff,$a2ff,$a2ff,$a3ff,$a3ff,$a3ff,$a4ff
	.word	$a4ff,$a5ff,$a5ff,$a6ff,$a6ff,$a7ff,$a7ff,$a8ff
	.word	$a9ff,$a9ff,$aaff,$abff,$acff,$adff,$adff,$aeff
	.word	$afff,$b0ff,$b1ff,$b2ff,$b3ff,$b4ff,$b5ff,$b6ff
	.word	$b7ff,$b8ff,$b9ff,$baff,$bbff,$bdff,$beff,$bfff
	.word	$c0ff,$c2ff,$c3ff,$c4ff,$c5ff,$c7ff,$c8ff,$c9ff
	.word	$cbff,$ccff,$ceff,$cfff,$d0ff,$d2ff,$d3ff,$d5ff
	.word	$d6ff,$d8ff,$d9ff,$dbff,$ddff,$deff,$e0ff,$e1ff
	.word	$e3ff,$e4ff,$e6ff,$e8ff,$e9ff,$ebff,$edff,$eeff
	.word	$f0ff,$f1ff,$f3ff,$f5ff,$f6ff,$f8ff,$faff,$fbff
	.word	$fdff,$ffff,$0000,$0100,$0300,$0500,$0600,$0800
	.word	$0a00,$0b00,$0d00,$0f00,$1000,$1200,$1300,$1500
	.word	$1700,$1800,$1a00,$1c00,$1d00,$1f00,$2000,$2200
	.word	$2300,$2500,$2700,$2800,$2a00,$2b00,$2d00,$2e00
	.word	$3000,$3100,$3200,$3400,$3500,$3700,$3800,$3900
	.word	$3b00,$3c00,$3d00,$3e00,$4000,$4100,$4200,$4300
	.word	$4500,$4600,$4700,$4800,$4900,$4a00,$4b00,$4c00
	.word	$4d00,$4e00,$4f00,$5000,$5100,$5200,$5300,$5300
	.word	$5400,$5500,$5600,$5700,$5700,$5800,$5900,$5900
	.word	$5a00,$5a00,$5b00,$5b00,$5c00,$5c00,$5d00,$5d00
	.word	$5d00,$5e00,$5e00,$5e00,$5f00,$5f00,$5f00,$5f00
	.word	$5f00,$5f00,$5f00,$5f00,$6000,$5f00,$5f00,$5f00
	.word	$5f00,$5f00,$5f00,$5f00,$5f00,$5e00,$5e00,$5e00
	.word	$5d00,$5d00,$5d00,$5c00,$5c00,$5b00,$5b00,$5a00
	.word	$5a00,$5900,$5900,$5800,$5700,$5700,$5600,$5500
	.word	$5400,$5300,$5300,$5200,$5100,$5000,$4f00,$4e00
	.word	$4d00,$4c00,$4b00,$4a00,$4900,$4800,$4700,$4600
	.word	$4500,$4300,$4200,$4100,$4000,$3e00,$3d00,$3c00
	.word	$3b00,$3900,$3800,$3700,$3500,$3400,$3200,$3100
	.word	$3000,$2e00,$2d00,$2b00,$2a00,$2800,$2700,$2500
	.word	$2300,$2200,$2000,$1f00,$1d00,$1c00,$1a00,$1800
	.word	$1700,$1500,$1300,$1200,$1000,$0f00,$0d00,$0b00
	.word	$0a00,$0800,$0600,$0500,$0300,$0100,$0000,$ffff
	.word	$fdff,$fbff,$faff,$f8ff,$f6ff,$f5ff,$f3ff,$f1ff
	.word	$f0ff,$eeff,$edff,$ebff,$e9ff,$e8ff,$e6ff,$e4ff
	.word	$e3ff,$e1ff,$e0ff,$deff,$ddff,$dbff,$d9ff,$d8ff
	.word	$d6ff,$d5ff,$d3ff,$d2ff,$d1ff,$cfff,$ceff,$ccff
	.word	$cbff,$c9ff,$c8ff,$c7ff,$c5ff,$c4ff,$c3ff,$c2ff
	.word	$c0ff,$bfff,$beff,$bdff,$bbff,$baff,$b9ff,$b8ff
	.word	$b7ff,$b6ff,$b5ff,$b4ff,$b3ff,$b2ff,$b1ff,$b0ff
	.word	$afff,$aeff,$adff,$adff,$acff,$abff,$aaff,$a9ff
	.word	$a9ff,$a8ff,$a7ff,$a7ff,$a6ff,$a6ff,$a5ff,$a5ff
	.word	$a4ff,$a4ff,$a3ff,$a3ff,$a3ff,$a2ff,$a2ff,$a2ff
	.word	$a1ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff
	.word	$a0ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff,$a1ff
	.word	$a1ff,$a2ff,$a2ff,$a2ff,$a3ff,$a3ff,$a3ff,$a4ff
	.word	$a4ff,$a5ff,$a5ff,$a6ff,$a6ff,$a7ff,$a7ff,$a8ff
	.word	$a9ff,$a9ff,$aaff,$abff,$acff,$adff,$adff,$aeff
	.word	$afff,$b0ff,$b1ff,$b2ff,$b3ff,$b4ff,$b5ff,$b6ff
	.word	$b7ff,$b8ff,$b9ff,$baff,$bbff,$bdff,$beff,$bfff
	.word	$c0ff,$c2ff,$c3ff,$c4ff,$c5ff,$c7ff,$c8ff,$c9ff
	.word	$cbff,$ccff,$ceff,$cfff,$d0ff,$d2ff,$d3ff,$d5ff
	.word	$d6ff,$d8ff,$d9ff,$dbff,$ddff,$deff,$e0ff,$e1ff
	.word	$e3ff,$e4ff,$e6ff,$e8ff,$e9ff,$ebff,$edff,$eeff
	.word	$f0ff,$f1ff,$f3ff,$f5ff,$f6ff,$f8ff,$faff,$fbff
	.word	$fdff,$ffff
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
M7CHR:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$001e,$001e,$001e,$001e,$0000,$0000,$0000,$0000
	.word	$0100,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0f01
	.word	$0d0e,$0b0c,$0809,$0507,$0304,$0c01,$080a,$0507
	.word	$0203,$0801,$0406,$0102,$0305,$0501,$0103,$0103
	.word	$0102,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0201
	.word	$0306,$0306,$0105,$0503,$0208,$0604,$0a08,$0302
	.word	$0705,$0a08,$010c,$0403,$0705,$0908,$0c0b,$0e0d
	.word	$010f,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0001
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0f0f
	.word	$0c0d,$0a0b,$0708,$0406,$0203,$0b01,$0709,$0406
	.word	$0102,$0709,$0305,$0701,$0204,$0401,$0102,$0102
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0305
	.word	$0401,$0401,$0206,$0604,$0301,$0705,$0109,$0403
	.word	$0806,$0b09,$0201,$0504,$0806,$0a09,$0d0c,$0f0e
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0100
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0f01,$0e0f
	.word	$0b0c,$090a,$0607,$0305,$0102,$0a0b,$0608,$0305
	.word	$0a01,$0608,$0204,$0601,$0103,$0306,$0401,$0101
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0201,$0401
	.word	$0502,$0502,$0301,$0705,$0402,$0806,$0201,$0504
	.word	$0907,$010a,$0302,$0605,$0907,$0b0a,$0e0d,$010f
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0001,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0f0e,$0d0e
	.word	$0a0b,$0809,$0506,$0204,$0c01,$090a,$0507,$0204
	.word	$0901,$0507,$0103,$0507,$0102,$0205,$0301,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0304,$0502
	.word	$0103,$0603,$0402,$0106,$0503,$0907,$0302,$0605
	.word	$0a08,$020b,$0403,$0706,$0a08,$0c0b,$0f0e,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0100,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0e01,$0e0f,$0c0d
	.word	$090a,$0708,$0405,$0103,$0b0c,$0809,$0406,$0103
	.word	$0809,$0406,$0102,$0406,$0601,$0104,$0105,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0101,$0401,$0103
	.word	$0204,$0704,$0503,$0207,$0604,$0108,$0403,$0706
	.word	$0b09,$0301,$0504,$0807,$0b09,$0d0c,$010f,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0001,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0f0e,$0d0f,$0b0c
	.word	$0809,$0607,$0304,$0102,$0a0b,$0708,$0305,$0102
	.word	$0708,$0305,$0701,$0305,$0501,$0103,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0202,$0102,$0204
	.word	$0305,$0105,$0604,$0301,$0705,$0209,$0504,$0807
	.word	$010a,$0402,$0605,$0908,$0c0a,$0e0d,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0100,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0d01,$0f0f,$0c0e,$0a0b
	.word	$0708,$0506,$0203,$0c01,$090a,$0607,$0204,$0901
	.word	$0607,$0204,$0601,$0204,$0401,$0102,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0201,$0303,$0203,$0301
	.word	$0401,$0206,$0705,$0402,$0806,$0301,$0605,$0908
	.word	$0201,$0503,$0706,$0a09,$0d0b,$010e,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0001,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0e0d,$0e0f,$0b0d,$090a
	.word	$0607,$0405,$0102,$0b0d,$0809,$0506,$0103,$080a
	.word	$0506,$0103,$0507,$0103,$0306,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0301,$0404,$0304,$0402
	.word	$0502,$0301,$0106,$0503,$0107,$0402,$0706,$0a09
	.word	$0302,$0604,$0807,$0b0a,$0e0c,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0100,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0d01,$0f0e,$0d0e,$0a0c,$0809
	.word	$0506,$0304,$0d01,$0a0c,$0708,$0405,$0102,$0709
	.word	$0405,$0102,$0406,$0102,$0105,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0201,$0102,$0101,$0401,$0503
	.word	$0603,$0402,$0207,$0604,$0208,$0503,$0807,$010a
	.word	$0403,$0705,$0908,$0c0b,$010d,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0001,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0e0c,$0f0f,$0c0d,$090b,$0708
	.word	$0405,$0203,$0c01,$090b,$0607,$0304,$0a01,$0608
	.word	$0304,$0801,$0305,$0701,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0100,$0203,$0202,$0102,$0104
	.word	$0104,$0503,$0301,$0705,$0301,$0604,$0908,$0201
	.word	$0504,$0806,$0a09,$0d0c,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0c01,$0f0d,$0e0f,$0b0c,$080a,$0607
	.word	$0304,$0102,$0b0d,$080a,$0506,$0203,$0901,$0507
	.word	$0203,$0701,$0204,$0101,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0001,$0200,$0301,$0303,$0203,$0205
	.word	$0205,$0604,$0402,$0806,$0402,$0705,$0109,$0302
	.word	$0605,$0907,$0b0a,$010d,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0001,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0d0c,$0f0e,$0d0e,$0a0b,$0709,$0506
	.word	$0203,$0e01,$0a0c,$0709,$0405,$0102,$080a,$0406
	.word	$0102,$0608,$0103,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0000,$0300,$0102,$0101,$0304,$0301
	.word	$0301,$0105,$0503,$0107,$0503,$0806,$0201,$0403
	.word	$0706,$0a08,$0c0b,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0b01,$0e0d,$0e0f,$0c0d,$090a,$0608,$0405
	.word	$0102,$0d0e,$090b,$0608,$0304,$0b01,$0709,$0305
	.word	$0901,$0507,$0102,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0001,$0000,$0101,$0201,$0202,$0401,$0402
	.word	$0402,$0206,$0604,$0201,$0604,$0907,$0302,$0504
	.word	$0807,$0b09,$010c,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0001,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0c0b,$0f0e,$0d0f,$0b0c,$0809,$0507,$0304
	.word	$0f01,$0c0d,$080a,$0507,$0203,$0a01,$0608,$0204
	.word	$0801,$0406,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0000,$0000,$0202,$0302,$0303,$0502,$0503
	.word	$0503,$0301,$0705,$0302,$0705,$0108,$0403,$0605
	.word	$0908,$0c0a,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0b01,$0d0c,$0f0f,$0c0e,$0a0b,$0708,$0406,$0203
	.word	$0e01,$0b0c,$0709,$0406,$0102,$090b,$0507,$0103
	.word	$0709,$0105,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0001,$0000,$0000,$0101,$0403,$0401,$0103,$0104
	.word	$0604,$0402,$0106,$0403,$0806,$0201,$0504,$0706
	.word	$0a09,$010b,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0001,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0c0b,$0e0d,$0e0f,$0b0d,$090a,$0607,$0305,$0102
	.word	$0d0e,$0a0b,$0608,$0305,$0c01,$080a,$0406,$0102
	.word	$0608,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0001,$0000,$0000,$0202,$0101,$0102,$0204,$0205
	.word	$0105,$0503,$0201,$0504,$0107,$0302,$0605,$0807
	.word	$0b0a,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0a01
	.word	$0d0c,$0f0e,$0d0e,$0a0c,$0809,$0506,$0204,$0f01
	.word	$0c0d,$090a,$0507,$0204,$0b01,$0709,$0305,$0a01
	.word	$0107,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0101
	.word	$0001,$0000,$0000,$0301,$0202,$0203,$0301,$0301
	.word	$0206,$0604,$0302,$0605,$0208,$0403,$0706,$0908
	.word	$010b,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0001
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0b0a
	.word	$0e0d,$0f0f,$0c0d,$090b,$0708,$0405,$0103,$0e0f
	.word	$0b0c,$0809,$0406,$0103,$0a0c,$0608,$0204,$0901
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0101
	.word	$0001,$0000,$0100,$0102,$0303,$0304,$0402,$0402
	.word	$0301,$0105,$0403,$0706,$0301,$0504,$0807,$0a09
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0a01,$0c0b
	.word	$0f0e,$0e0f,$0b0c,$080a,$0607,$0304,$0102,$0d0f
	.word	$0a0b,$0708,$0305,$0102,$090b,$0507,$0103,$010a
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0101,$0101
	.word	$0001,$0000,$0200,$0201,$0101,$0401,$0103,$0503
	.word	$0402,$0206,$0504,$0107,$0402,$0605,$0908,$010a
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0001,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0b00,$0d0c
	.word	$0f0f,$0d0e,$0a0b,$0709,$0506,$0203,$0f01,$0c0e
	.word	$090a,$0607,$0204,$0c01,$080a,$0406,$0102,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0102,$0101
	.word	$0001,$0000,$0100,$0102,$0202,$0102,$0204,$0104
	.word	$0503,$0301,$0605,$0201,$0503,$0706,$0a09,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0001,$0c00,$0e0d
	.word	$0e0f,$0c0d,$090a,$0608,$0405,$0102,$0e0f,$0b0d
	.word	$0809,$0506,$0103,$0b0d,$0709,$0305,$0101,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0201,$0101,$0101
	.word	$0000,$0000,$0200,$0203,$0303,$0203,$0301,$0201
	.word	$0104,$0402,$0706,$0302,$0604,$0807,$010a,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0001,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0000,$0d00,$0f0e
	.word	$0d0e,$0b0c,$0809,$0507,$0304,$0e01,$0d0f,$0a0c
	.word	$0708,$0405,$0102,$0a0c,$0608,$0204,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0102,$0101,$0101
	.word	$0000,$0000,$0100,$0301,$0101,$0301,$0402,$0302
	.word	$0205,$0503,$0107,$0403,$0705,$0908,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0001,$0000,$0e00,$0f0f
	.word	$0c0d,$0a0b,$0708,$0406,$0203,$0f01,$0c0e,$090b
	.word	$0607,$0304,$0d01,$090b,$0507,$0103,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0301,$0201,$0101,$0101
	.word	$0000,$0000,$0200,$0102,$0202,$0402,$0103,$0403
	.word	$0301,$0604,$0201,$0504,$0806,$0109,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0001,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0000,$0000,$0f00,$0e0f
	.word	$0b0c,$090a,$0607,$0305,$0102,$0f0f,$0b0d,$080a
	.word	$0506,$0203,$0c01,$080a,$0406,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0203,$0101,$0101,$0101
	.word	$0000,$0000,$0101,$0201,$0303,$0103,$0204,$0504
	.word	$0402,$0105,$0302,$0605,$0907,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0001,$0000,$0000,$0f00,$0d0e
	.word	$0a0b,$0809,$0506,$0204,$0001,$0e0f,$0a0c,$0709
	.word	$0405,$0102,$0b0d,$0709,$0105,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0301,$0102,$0101,$0101,$0101
	.word	$0000,$0000,$0201,$0102,$0101,$0204,$0301,$0105
	.word	$0503,$0206,$0403,$0706,$0108,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0001,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0000,$0000,$0000,$0e00,$0c0d
	.word	$090a,$0708,$0405,$0103,$0000,$0d0e,$090b,$0608
	.word	$0304,$0e01,$0a0c,$0608,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0204,$0201,$0101,$0101,$0001
	.word	$0000,$0000,$0102,$0201,$0202,$0301,$0402,$0201
	.word	$0604,$0301,$0504,$0807,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0001,$0000,$0000,$0000,$0d00,$0b0c
	.word	$0809,$0607,$0304,$0102,$0000,$0c0d,$080a,$0507
	.word	$0203,$0d01,$090b,$0107,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0401,$0103,$0102,$0101,$0101,$0001
	.word	$0000,$0000,$0201,$0302,$0301,$0102,$0503,$0302
	.word	$0105,$0402,$0605,$0108,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0101,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0001,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0100,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0000,$0000,$0000,$0000,$0c00,$0a0b
	.word	$0708,$0506,$0203,$0001,$0000,$0b0c,$0709,$0406
	.word	$0102,$0c00,$080a,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0304,$0102,$0201,$0101,$0101,$0001
	.word	$0000,$0000,$0101,$0101,$0102,$0203,$0104,$0403
	.word	$0201,$0503,$0706,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0201,$0000,$0000,$0000,$0000,$0000
	.word	$0100,$0002,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0201,$0a0b,$0809,$0607,$0405
	.word	$0203,$0001,$0000,$0000,$0000,$0000,$0b00,$090a
	.word	$0607,$0405,$0102,$0000,$0000,$0a0b,$0608,$0305
	.word	$0001,$0b00,$0109,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0501,$0203,$0201,$0101,$0101,$0101,$0001
	.word	$0000,$0100,$0202,$0202,$0203,$0301,$0201,$0504
	.word	$0302,$0604,$0107,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0001,$0302,$0000,$0000,$0000,$0000,$0000
	.word	$0201,$0003,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0100,$0302,$090a,$0708,$0506,$0304
	.word	$0102,$0000,$0000,$0000,$0000,$0000,$0a00,$0809
	.word	$0506,$0304,$0001,$0000,$0000,$090a,$0507,$0204
	.word	$0001,$0a00,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0405,$0102,$0103,$0102,$0101,$0101,$0001
	.word	$0000,$0100,$0101,$0101,$0301,$0402,$0302,$0105
	.word	$0403,$0705,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0100,$0403,$0000,$0000,$0000,$0000,$0000
	.word	$0302,$0004,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0201,$0403,$0809,$0607,$0405,$0203
	.word	$0001,$0000,$0000,$0000,$0000,$0000,$0900,$0708
	.word	$0405,$0203,$0001,$0000,$0000,$0809,$0406,$0103
	.word	$0000,$0100,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0501,$0304,$0301,$0102,$0101,$0101,$0101,$0001
	.word	$0000,$0200,$0101,$0202,$0102,$0103,$0403,$0201
	.word	$0504,$0106,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0001,$0200,$0504,$0000,$0000,$0000,$0000,$0100
	.word	$0403,$0005,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0100,$0302,$0504,$0708,$0506,$0304,$0102
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0800,$0607
	.word	$0304,$0102,$0000,$0000,$0000,$0708,$0305,$0102
	.word	$0000,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0405,$0203,$0201,$0201,$0101,$0101,$0101,$0000
	.word	$0000,$0100,$0202,$0303,$0203,$0204,$0104,$0302
	.word	$0605,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0000,$0301,$0605,$0000,$0000,$0000,$0000,$0201
	.word	$0504,$0006,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0201,$0403,$0605,$0607,$0405,$0203,$0001
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0700,$0506
	.word	$0203,$0001,$0000,$0000,$0000,$0607,$0204,$0001
	.word	$0100,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0601
	.word	$0304,$0102,$0103,$0103,$0101,$0101,$0101,$0000
	.word	$0000,$0100,$0101,$0101,$0301,$0301,$0201,$0403
	.word	$0106,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0001
	.word	$0100,$0402,$0706,$0000,$0000,$0000,$0100,$0302
	.word	$0605,$0007,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0100,$0302,$0504,$0706,$0506,$0304,$0102,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0600,$0405
	.word	$0102,$0000,$0000,$0000,$0000,$0506,$0103,$0000
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0506
	.word	$0203,$0401,$0102,$0102,$0101,$0101,$0101,$0000
	.word	$0000,$0101,$0202,$0202,$0102,$0402,$0302,$0504
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0000
	.word	$0200,$0503,$0807,$0000,$0000,$0000,$0201,$0403
	.word	$0706,$0008,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0201,$0403,$0605,$0807,$0405,$0203,$0001,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0500,$0304
	.word	$0001,$0000,$0000,$0000,$0000,$0405,$0102,$0100
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0601,$0405
	.word	$0102,$0304,$0301,$0201,$0101,$0101,$0101,$0000
	.word	$0000,$0101,$0101,$0101,$0203,$0103,$0403,$0105
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0001,$0000
	.word	$0301,$0604,$0908,$0000,$0000,$0000,$0302,$0504
	.word	$0807,$0009,$0000,$0000,$0000,$0000,$0000,$0100
	.word	$0302,$0504,$0706,$0908,$0304,$0102,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0400,$0203
	.word	$0001,$0000,$0000,$0000,$0000,$0304,$0001,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0507,$0304
	.word	$0501,$0203,$0201,$0101,$0101,$0101,$0101,$0000
	.word	$0000,$0201,$0201,$0202,$0301,$0201,$0504,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$000a,$0000
	.word	$0402,$0705,$0a09,$0000,$0000,$0100,$0403,$0605
	.word	$0908,$000a,$0000,$0000,$0000,$0000,$0000,$0201
	.word	$0403,$0605,$0807,$0a09,$0203,$0001,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0300,$0102
	.word	$0000,$0000,$0000,$0000,$0000,$0203,$0101,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0701,$0406,$0203
	.word	$0401,$0102,$0103,$0102,$0101,$0101,$0001,$0000
	.word	$0000,$0101,$0102,$0301,$0102,$0302,$0105,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0901,$000b,$0100
	.word	$0503,$0806,$0b0a,$0000,$0000,$0201,$0504,$0706
	.word	$0a09,$000b,$0000,$0000,$0000,$0000,$0100,$0302
	.word	$0504,$0706,$0908,$0b0a,$0102,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0200,$0001
	.word	$0000,$0000,$0000,$0000,$0000,$0102,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0607,$0305,$0102
	.word	$0304,$0401,$0102,$0201,$0101,$0101,$0001,$0000
	.word	$0000,$0101,$0201,$0102,$0203,$0403,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0a08,$000c,$0201
	.word	$0604,$0907,$0c0b,$0000,$0100,$0302,$0605,$0807
	.word	$0b0a,$000c,$0000,$0000,$0000,$0000,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0001,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0100,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0101,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0801,$0506,$0204,$0501
	.word	$0203,$0301,$0201,$0101,$0101,$0101,$0001,$0000
	.word	$0000,$0101,$0101,$0201,$0301,$0104,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0701,$0b09,$000d,$0302
	.word	$0705,$0a08,$0d0c,$0000,$0200,$0403,$0706,$0908
	.word	$0c0b,$000d,$0000,$0000,$0000,$0100,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0708,$0405,$0103,$0406
	.word	$0102,$0204,$0101,$0102,$0101,$0101,$0001,$0000
	.word	$0100,$0101,$0202,$0102,$0402,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0806,$0c0a,$010e,$0403
	.word	$0806,$0b09,$0e0d,$0000,$0301,$0504,$0807,$0a09
	.word	$0d0c,$000e,$0000,$0000,$0000,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0100,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0801,$0607,$0304,$0102,$0305
	.word	$0501,$0103,$0102,$0101,$0101,$0101,$0001,$0000
	.word	$0100,$0201,$0101,$0201,$0103,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0501,$0907,$0d0b,$0201,$0504
	.word	$0907,$0c0a,$0f0e,$0100,$0402,$0605,$0908,$0b0a
	.word	$0e0d,$000f,$0000,$0000,$0100,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0709,$0506,$0203,$0501,$0204
	.word	$0401,$0102,$0301,$0101,$0101,$0101,$0000,$0000
	.word	$0100,$0101,$0201,$0302,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0604,$0a08,$0e0c,$0302,$0605
	.word	$0a08,$0d0b,$0f0f,$0201,$0503,$0706,$0a09,$0c0b
	.word	$0f0e,$000f,$0000,$0000,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0100,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0901,$0608,$0405,$0102,$0406,$0103
	.word	$0304,$0301,$0201,$0101,$0101,$0101,$0000,$0000
	.word	$0100,$0101,$0102,$0103,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0301,$0705,$0b09,$010d,$0403,$0706
	.word	$0b09,$0e0c,$0e0f,$0302,$0604,$0807,$0b0a,$0d0c
	.word	$0f0f,$000e,$0000,$0100,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0809,$0507,$0304,$0701,$0305,$0102
	.word	$0203,$0201,$0101,$0101,$0101,$0101,$0000,$0000
	.word	$0100,$0101,$0201,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0402,$0806,$0c0a,$020e,$0504,$0807
	.word	$0c0a,$0f0d,$010e,$0403,$0705,$0908,$0c0b,$0e0d
	.word	$0e0f,$000d,$0000,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0100,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0a01,$0708,$0406,$0203,$0601,$0204,$0401
	.word	$0102,$0103,$0102,$0101,$0101,$0101,$0000,$0000
	.word	$0101,$0101,$0102,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0101,$0503,$0907,$0d0b,$0301,$0605,$0908
	.word	$0d0b,$0f0e,$0201,$0504,$0806,$0a09,$0d0c,$0f0e
	.word	$0d0e,$000c,$0100,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$090a,$0607,$0305,$0102,$0506,$0103,$0305
	.word	$0401,$0102,$0201,$0101,$0101,$0101,$0000,$0000
	.word	$0101,$0201,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$020b,$0604,$0a08,$010c,$0402,$0706,$0a09
	.word	$0e0c,$010f,$0302,$0605,$0907,$0b0a,$0e0d,$0f0f
	.word	$0c0d,$000b,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0100,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0a01,$0809,$0506,$0204,$0701,$0405,$0102,$0204
	.word	$0301,$0301,$0101,$0101,$0101,$0101,$0000,$0000
	.word	$0101,$0101,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0a01,$0301,$0705,$0b09,$020d,$0503,$0807,$0b0a
	.word	$0f0d,$020f,$0403,$0706,$0a08,$0c0b,$0f0e,$0e0f
	.word	$0b0c,$010a,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$090a,$0708,$0405,$0103,$0607,$0304,$0501,$0103
	.word	$0204,$0201,$0101,$0101,$0101,$0001,$0000,$0000
	.word	$0101,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0b09,$0402,$0806,$0c0a,$0301,$0604,$0908,$0c0b
	.word	$0f0e,$0301,$0504,$0807,$0b09,$0d0c,$0f0f,$0d0e
	.word	$0a0b,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0100,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0b01
	.word	$0809,$0607,$0304,$0102,$0506,$0203,$0401,$0102
	.word	$0103,$0103,$0102,$0101,$0101,$0001,$0000,$0000
	.word	$0101,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0701
	.word	$010a,$0503,$0907,$0d0b,$0402,$0705,$0a09,$0d0c
	.word	$010f,$0402,$0605,$0908,$0c0a,$0e0d,$0e0f,$0c0d
	.word	$010a,$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e
	.word	$0e0f,$0c0d,$0a0b,$0809,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0a0b
	.word	$0708,$0506,$0203,$0701,$0405,$0102,$0305,$0501
	.word	$0102,$0102,$0201,$0101,$0101,$0001,$0000,$0000
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102,$0806
	.word	$020b,$0604,$0a08,$010c,$0503,$0806,$0b0a,$0e0d
	.word	$0201,$0503,$0706,$0a09,$0d0b,$0f0e,$0d0e,$0b0c
	.word	$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f
	.word	$0d0e,$0b0c,$090a,$0708,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0100
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0b01,$090a
	.word	$0607,$0405,$0102,$0608,$0304,$0601,$0204,$0401
	.word	$0401,$0301,$0101,$0101,$0101,$0001,$0000,$0100
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0405,$0203,$0501,$0907
	.word	$0301,$0705,$0b09,$0201,$0604,$0907,$0c0b,$0f0e
	.word	$0302,$0604,$0807,$0b0a,$0e0c,$0f0f,$0c0d,$010b
	.word	$0302,$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f
	.word	$0c0d,$0a0b,$0809,$0607,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0a0c,$0809
	.word	$0506,$0304,$0801,$0507,$0203,$0501,$0103,$0305
	.word	$0301,$0201,$0101,$0101,$0101,$0001,$0000,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0304,$0102,$0604,$0a08
	.word	$0402,$0806,$0c0a,$0302,$0705,$0a08,$0d0c,$010f
	.word	$0403,$0705,$0908,$0c0b,$0f0d,$0e0f,$0b0c,$0201
	.word	$0403,$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e
	.word	$0b0c,$090a,$0708,$0506,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0100,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0c01,$090b,$0708
	.word	$0405,$0203,$0701,$0406,$0102,$0406,$0102,$0204
	.word	$0201,$0101,$0102,$0101,$0101,$0000,$0100,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0203,$0201,$0705,$0109
	.word	$0503,$0907,$010b,$0403,$0806,$0b09,$0e0d,$0201
	.word	$0504,$0806,$0a09,$0d0c,$0f0e,$0d0e,$010b,$0302
	.word	$0504,$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d
	.word	$0a0b,$0809,$0607,$0405,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0000,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0b0c,$080a,$0607
	.word	$0304,$0102,$0608,$0305,$0701,$0305,$0501,$0103
	.word	$0103,$0103,$0101,$0101,$0101,$0000,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0102,$0301,$0806,$0201
	.word	$0604,$0a08,$0201,$0504,$0907,$0c0a,$010e,$0302
	.word	$0605,$0907,$0b0a,$0e0d,$0e0f,$0c0d,$0201,$0403
	.word	$0605,$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c
	.word	$090a,$0708,$0506,$0304,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0100,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0d01,$0a0b,$0709,$0506
	.word	$0203,$0901,$0507,$0204,$0601,$0204,$0401,$0102
	.word	$0102,$0102,$0101,$0101,$0101,$0100,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0801,$0402,$0907,$0302
	.word	$0705,$0b09,$0302,$0605,$0a08,$0d0b,$0201,$0403
	.word	$0706,$0a08,$0c0b,$0f0e,$0d0f,$010c,$0302,$0504
	.word	$0706,$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b
	.word	$0809,$0607,$0405,$0203,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0000,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0c0d,$090a,$0608,$0405
	.word	$0102,$0809,$0406,$0103,$0507,$0103,$0305,$0401
	.word	$0401,$0201,$0101,$0101,$0101,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0107,$0503,$0108,$0403
	.word	$0806,$010a,$0403,$0706,$0b09,$0e0c,$0302,$0504
	.word	$0807,$0b09,$0d0c,$0f0f,$0c0e,$0201,$0403,$0605
	.word	$0807,$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a
	.word	$0708,$0506,$0304,$0102,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0100,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0d01,$0b0c,$0809,$0507,$0304
	.word	$0a01,$0708,$0305,$0102,$0406,$0102,$0204,$0301
	.word	$0301,$0101,$0101,$0101,$0101,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0501,$0208,$0604,$0209,$0504
	.word	$0907,$020b,$0504,$0807,$0c0a,$010d,$0403,$0605
	.word	$0908,$0c0a,$0e0d,$0e0f,$010d,$0302,$0504,$0706
	.word	$0908,$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809
	.word	$0607,$0405,$0203,$0001,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0000,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0c0e,$0a0b,$0708,$0406,$0203
	.word	$0901,$0607,$0204,$0701,$0305,$0601,$0103,$0205
	.word	$0201,$0101,$0101,$0101,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0603,$0301,$0705,$0301,$0605
	.word	$0a08,$0301,$0605,$0908,$0d0b,$0201,$0504,$0706
	.word	$0a09,$0d0b,$0f0e,$0d0e,$0201,$0403,$0605,$0807
	.word	$0a09,$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708
	.word	$0506,$0304,$0102,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0100,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0e01,$0b0d,$090a,$0607,$0305,$0102
	.word	$0809,$0506,$0103,$0608,$0204,$0501,$0102,$0104
	.word	$0103,$0102,$0101,$0101,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0201,$0704,$0402,$0806,$0402,$0706
	.word	$0109,$0402,$0706,$0a09,$010c,$0302,$0605,$0807
	.word	$0b0a,$0e0c,$0f0f,$010d,$0302,$0504,$0706,$0908
	.word	$0b0a,$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607
	.word	$0405,$0203,$0001,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0000,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0d0e,$0a0c,$0809,$0506,$0204,$0a01
	.word	$0708,$0405,$0102,$0507,$0103,$0406,$0501,$0103
	.word	$0102,$0201,$0101,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0307,$0805,$0503,$0107,$0503,$0807
	.word	$020a,$0503,$0807,$0b0a,$020d,$0403,$0706,$0908
	.word	$0c0b,$0f0d,$0e0f,$0201,$0403,$0605,$0807,$0a09
	.word	$0c0b,$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506
	.word	$0304,$0102,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0100,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0f01,$0c0d,$090b,$0708,$0405,$0103,$090b
	.word	$0607,$0304,$0801,$0406,$0102,$0305,$0401,$0102
	.word	$0301,$0101,$0101,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0501,$0401,$0106,$0604,$0208,$0604,$0908
	.word	$0301,$0604,$0908,$0c0b,$0301,$0504,$0807,$0a09
	.word	$0d0c,$0f0e,$010e,$0302,$0504,$0706,$0908,$0b0a
	.word	$0d0c,$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405
	.word	$0203,$0001,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0000,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0e0f,$0b0c,$080a,$0607,$0304,$0102,$080a
	.word	$0506,$0203,$0701,$0305,$0601,$0204,$0301,$0301
	.word	$0201,$0101,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0603,$0502,$0207,$0705,$0301,$0705,$0a09
	.word	$0402,$0705,$0a09,$010c,$0402,$0605,$0908,$0b0a
	.word	$0e0d,$0e0f,$0201,$0403,$0605,$0807,$0a09,$0c0b
	.word	$0e0d,$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304
	.word	$0102,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0100,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0f01,$0d0e,$0a0b,$0709,$0506,$0203,$0a01,$0709
	.word	$0405,$0102,$0608,$0204,$0501,$0103,$0205,$0201
	.word	$0101,$0102,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0101,$0104,$0603,$0301,$0806,$0402,$0806,$010a
	.word	$0503,$0806,$0b0a,$0201,$0503,$0706,$0a09,$0c0b
	.word	$0f0e,$010f,$0302,$0504,$0706,$0908,$0b0a,$0d0c
	.word	$0f0e,$0e0f,$0c0d,$0a0b,$0809,$0607,$0405,$0203
	.word	$0001,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word	$0000,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0e0f,$0c0d,$090a,$0608,$0405,$0102,$090b,$0608
	.word	$0304,$0901,$0507,$0103,$0406,$0102,$0104,$0104
	.word	$0103,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
	.word	$0205,$0205,$0704,$0402,$0107,$0503,$0907,$0201
	.word	$0604,$0907,$0c0b,$0302,$0604,$0807,$0b0a,$0d0c
	.word	$0f0f,$0201,$0403,$0605,$0807,$0a09,$0c0b,$0e0d
	.word	$0f0f,$0d0e,$0b0c,$090a,$0708,$0506,$0304,$0102
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
