;-------------------------------------------------------------------------;
.include "graphics.inc"
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;
.export LargeScreen
;-------------------------------------------------------------------------;

; artwork by ansimuz
; "Warped City"
; https://opengameart.org/users/ansimuz
; http://www.patreon.com/ansimuz
; https://creativecommons.org/publicdomain/zero/1.0/

;-------------------------------------------------------------------------;
BG1MAP	= 0000h
BG2MAP	= 7800h
BG3MAP	= 7c00h
BG1GFX	= 0800h
BG2GFX	= 6000h
BG3GFX	= 7000h
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
RAM_BG3HOFS = m4
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
bg1hofs	= m1
bg2hofs	= m2
bg3hofs = m3
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
LargeScreen:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	DoDecompressDataVram gfx_bg1Tiles, BG1GFX*2
	DoDecompressDataVram gfx_bg1Map, BG1MAP*2
	DoDecompressDataVram gfx_bg2Tiles, BG2GFX*2
	DoDecompressDataVram gfx_bg2Map, BG2MAP*2
	DoDecompressDataVram gfx_bg3Tiles, BG3GFX*2
	DoDecompressDataVram gfx_bg3Map, BG3MAP*2

	DoCopyPalette gfx_bg3Pal, 16, 7
	DoCopyPalette gfx_bg1Pal, 32, 16
	DoCopyPalette gfx_bg2Pal, 64, 16

	lda	#VMAIN_INCH
	sta	REG_VMAIN

	ldx	#BG3MAP+240h
	stx	REG_VMADDL

	ldx	#0080h

	lda	#14h			; change palette for bg3 buildings
:	sta	REG_VMDATAH
	dex
	bpl	:-

	lda	#60h
	sta	RAM_BG3HOFS

	lda	#BGMODE_1
	sta	REG_BGMODE

	sta	RAM_BG3HOFS+3

	lda	#BG1MAP>>8|SC_64x32
	sta	REG_BG1SC

	lda	#BG2MAP>>8
	sta	REG_BG2SC

	lda	#BG3MAP>>8
	sta	REG_BG3SC

	lda	#BG2GFX>>8|BG1GFX>>12
	sta	REG_BG12NBA

	lda	#BG3GFX>>12
	sta	REG_BG34NBA

	lda	#TM_BG3|TM_BG2|TM_BG1
	sta	REG_TM

	and	#2
	sta	REG_DMAP0
	sta	REG_DMAP2

	lda	#<REG_BG3HOFS
	sta	REG_BBAD0
	ldx	#RAM_BG3HOFS
	stx	REG_A1T0L
	stz	REG_A1B0

	stz	REG_DMAP1
	lda	#<REG_CGADD
	sta	REG_BBAD1
	ldx	#LIST_CGADD
	stx	REG_A1T1L
	stz	REG_A1B1

	lda	#<REG_CGDATA
	sta	REG_BBAD2
	ldx	#LIST_CGDATA
	stx	REG_A1T2L
	stz	REG_A1B2

	lda	#%111
	sta	REG_HDMAEN

	lda	#0ffh
	sta	REG_BG1VOFS
	stz	REG_BG1VOFS
	sta	REG_BG2VOFS
	stz	REG_BG2VOFS
	sta	REG_BG3VOFS
	stz	REG_BG3VOFS

	and	#0fh
	sta	REG_INIDISP
;=========================================================================;
Loop:
;=========================================================================;
	lda	REG_RDNMI
	bpl	Loop
;-------------------------------------------------------------------------;
	rep	#30h

	inc	bg1hofs
	lda	bg1hofs

	sep	#20h

	sta	REG_BG1HOFS
	xba
	and	#%11
	sta	REG_BG1HOFS

	lda	bg2hofs+1
	clc
	adc	#80h
	sta	bg2hofs+1

	lda	bg2hofs
	adc	#0
	sta	bg2hofs
	sta	REG_BG2HOFS
	stz	REG_BG2HOFS

	lda	bg3hofs
	clc
	adc	#40h
	sta	bg3hofs

	lda	RAM_BG3HOFS+4
	adc	#0
	sta	RAM_BG3HOFS+4

	lda	bg3hofs+1
	clc
	adc	#20h
	sta	bg3hofs+1

	lda	RAM_BG3HOFS+1
	adc	#0
	sta	RAM_BG3HOFS+1
	bra	Loop


; 500050 880850 e09840	; purples/ yellow
; 200048 500050 880850	; black purles
; 000050 000858 001870	; black blue blue blue

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_CGADD:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00
	.byte 0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_CGADD_END:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_CGDATA:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $1800
	.byte $01
	.word $2800
	.byte $01
	.word $5603
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $227c
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $227c
	.byte $01
	.word $5603
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $1c00
	.byte $01
	.word $209d
	.byte $01
	.word $2800
	.byte $01
	.word $2800
	.byte $01
	.word $5603
	.byte $01
	.word $280a
	.byte $01
	.word $5603
	.byte $01
	.word $280a
	.byte $01
	.word $1c00
	.byte $01
	.word $227c
	.byte $01
	.word $280a
	.byte $01
	.word $209d
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $209d
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $227c
	.byte $01
	.word $227c
	.byte $01
	.word $5603
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $280a
	.byte $01
	.word $2800
	.byte $01
	.word $280a
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $5603
	.byte $01
	.word $227c
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $5603
	.byte $01
	.word $209d
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $2800
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $2000
	.byte $01
	.word $1c00
	.byte $01
	.word $1c00
	.byte $01
	.word $2000
	.byte $01
	.word $1c00
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2001
	.byte $01
	.word $2000
	.byte $01
	.word $2000
	.byte $01
	.word $2001
	.byte $01
	.word $2000
	.byte $01
	.word $2001
	.byte $01
	.word $2001
	.byte $01
	.word $2001
	.byte $01
	.word $2001
	.byte $01
	.word $2001
	.byte $01
	.word $2001
	.byte $01
	.word $2002
	.byte $01
	.word $2001
	.byte $01
	.word $2002
	.byte $01
	.word $2002
	.byte $01
	.word $2402
	.byte $01
	.word $2403
	.byte $01
	.word $2404
	.byte $01
	.word $2805
	.byte $01
	.word $2806
	.byte $01
	.word $2807
	.byte $01
	.word $2808
	.byte $01
	.word $2809
	.byte $01
	.word $280a
	.byte $01
	.word $282b
	.byte $01
	.word $282c
	.byte $01
	.word $282d
	.byte $01
	.word $284e
	.byte $01
	.word $284f
	.byte $01
	.word $2850
	.byte $01
	.word $2851
	.byte $01
	.word $2852
	.byte $01
	.word $2453
	.byte $01
	.word $2454
	.byte $01
	.word $2455
	.byte $01
	.word $2456
	.byte $01
	.word $2477
	.byte $01
	.word $2478
	.byte $01
	.word $2479
	.byte $01
	.word $247a
	.byte $01
	.word $247b
	.byte $01
	.word $209c
	.byte $01
	.word $209d
	.byte $01
	.word $20bd
	.byte $01
	.word $20dd
	.byte $01
	.word $20fd
	.byte $01
	.word $211d
	.byte $01
	.word $213d
	.byte $01
	.word $215d
	.byte $01
	.word $217d
	.byte $01
	.word $219c
	.byte $01
	.word $21bc
	.byte $01
	.word $21dc
	.byte $01
	.word $21fc
	.byte $01
	.word $221c
	.byte $01
	.word $223c
	.byte $01
	.word $225c
	.byte $01
	.word $227c
	.byte $01
	.word $227c
	.byte $01
	.word $227c
	.byte $01
	.word $227c
	.byte $01
	.word $1801	;bldg
	.byte $01
	.word $1801
	.byte $01
	.word $1801
	.byte $01
	.word $1801
	.byte $01
	.word $1801
	.byte $01
	.word $1801
	.byte $01
	.word $1801
	.byte $01
	.word $1801
	.byte $01
	.word $2800
	.byte $01
	.word $2820
	.byte $01
	.word $2820
	.byte $01
	.word $2c20
	.byte $01
	.word $2c20
	.byte $01
	.word $2c20
	.byte $01
	.word $3020
	.byte $01
	.word $2c20
	.byte $01
	.word $3020
	.byte $01
	.word $3020
	.byte $01
	.word $3040
	.byte $01
	.word $3020
	.byte $01
	.word $3040
	.byte $01
	.word $3040
	.byte $01
	.word $3040
	.byte $01
	.word $3040
	.byte $01
	.word $3440
	.byte $01
	.word $3440
	.byte $01
	.word $3440
	.byte $01
	.word $3440
	.byte $01
	.word $3440
	.byte $01
	.word $3440
	.byte $01
	.word $3440
	.byte $01
	.word $3840
	.byte $01
	.word $3440
	.byte $01
	.word $3840
	.byte $01
	.word $3840
	.byte $01
	.word $3840
	.byte $01
	.word $3840
	.byte $01
	.word $3840
	.byte $01
	.word $3840
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c40
	.byte $01
	.word $3c60
	.byte $01
	.word $3c40
	.byte $01
	.word $3c60
	.byte $01
	.word $3c60
	.byte $01
	.word $3c60
	.byte $01
	.word $3c60
	.byte $01
	.word $3c60
	.byte $01
	.word $3c60
	.byte 0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_CGDATA_END:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;

