;-------------------------------------------------------------------------;
.include "copy256x256m7.inc"
.include "graphics.inc"
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;
.export DoRaiderCredits
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
end_flag	= m0
coldata_index	= m6
m7a_m7d_index	= m7
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
DoRaiderCredits:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	sei

	DoCopyPalette M7PAL, 0, 16

	lda	#^M7MAP
	ldx	#M7GFX
	ldy	#M7MAP
	jsr	Copy256x256Mode7Gfx

	lda	#BGMODE_7
	sta	REG_BGMODE
	stz	REG_BG1SC
	stz	REG_BG12NBA
	lda	#TM_BG1
	sta	REG_TM

	lda	#08h
	sta	REG_BG1VOFS
	stz	REG_BG1VOFS

	lda	#%11000000
	sta	REG_M7SEL

	lda	#80h
	sta	REG_M7X
	stz	REG_M7X
	sta	REG_M7Y
	stz	REG_M7Y

	ldx	#LIST_M7A_M7D
	stx	m7a_m7d_index
	ldx	#LIST_COLDATA
	stx	coldata_index

	lda	#02h
	sta	REG_CGSWSEL
	lda	#0a1h
	sta	REG_CGADSUB

	jsr	HDMA

	lda	#NMI_ON|NMI_JOYPAD
	sta	REG_NMITIMEN

	cli

	ldx	#0000h
:	lda	REG_RDNMI
	and	#80h
	beq	:-
	lda	REG_RDNMI
	inx
	cpx	#000ah
	bne	:-

	lda	#0fh
	sta	REG_INIDISP
;-------------------------------------------------------------------------;
loop:
;-------------------------------------------------------------------------;
	lda	REG_RDNMI
	and	#80h
	beq	loop
;-------------------------------------------------------------------------;
	jsr	HDMA

	lda	REG_RDNMI
	lda	end_flag
	beq	loop
;-------------------------------------------------------------------------;
	stz	REG_HDMAEN
	rts


;=========================================================================;
HDMA:
;=========================================================================;
	stz	REG_HDMAEN

	lda	#DMAP_XFER_MODE_2
	sta	REG_DMAP0
	sta	REG_DMAP1

	lda	#<REG_M7A
	sta	REG_BBAD0
	ldx	m7a_m7d_index
	stx	REG_A1T0L
	stx	REG_A1T1L
	stz	REG_A1B0
	stz	REG_A1B1

	lda	#<REG_M7D
	sta	REG_BBAD1

	stz	REG_DMAP2
	lda	#<REG_COLDATA
	sta	REG_BBAD2
	ldy	coldata_index
	sty	REG_A1T2L
	stz	REG_A1B2

	lda	#%111
	sta	REG_HDMAEN

	cpx	#0b96ch
	bmi	:+
;-------------------------------------------------------------------------;
	lda	#8fh
	sta	REG_INIDISP
	lda	#1
	sta	end_flag
;-------------------------------------------------------------------------;
:	inx
	inx
	inx
	iny
	iny
	inx
	inx
	inx
	iny
	iny
	inx
	inx
	inx
	iny
	iny
	inx
	inx
	inx
	iny
	iny
;-------------------------------------------------------------------------;
	stx	m7a_m7d_index
	sty	coldata_index
	rts


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_COLDATA:	.incbin	"../data/list_coldata.bin"
LIST_M7A_M7D:	.incbin	"../data/list_m7a_m7b.bin"
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;/////////////////////////////////////////////////////////////////////////;
.segment "DATA"
;/////////////////////////////////////////////////////////////////////////;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
M7MAP:	.incbin	"../mode7gfx/dist.bin"
M7PAL:	.incbin	"../mode7gfx/dist.pal"
M7GFX:	.incbin	"../mode7gfx/dist.pc7"
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
