;-------------------------------------------------------------------------;
.include "plasma.inc"
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_init.inc"
.include "snes_zvars.inc"
.include "spaceplane.inc"
;-------------------------------------------------------------------------;


;=========================================================================;
;      Code (c) 1993-94 -Pan-/ANTHROX   All code can be used at will!
;=========================================================================; 


;-------------------------------------------------------------------------;
COLOR_RAM = 7f5000h
PLASMA_MAP = 7f4000h
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
color_ptr = m2
plasma_sine_addr1 = m4
plasma_sine_addr2 = m5
plasma_sine_addr3 = m6
plasma_sine_addr4 = m7
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.zeropage
;/////////////////////////////////////////////////////////////////////////;



;-------------------------------------------------------------------------;
HDMAdis1:
	.res 2
HDMAdis2:
	.res 2
HDMAoffset1:
	.res 2
HDMAoffset2:
	.res 2
Storage:
	.res 2
Storage2:
	.res 2
blend2131:
	.res 2
blendbitsoffset:
	.res 2
blendbrightoffset:
	.res 2
blendflip:
	.res 2
blendflip2:
	.res 2
matrixacos:
	.res 2
matrixaoffset:
	.res 2
matrixdcos:
	.res 2
plasma_bar:
	.res 1
plasmahscrpos:
	.res 2
plasma_mode:
	.res 2
plasmavscrpos:
	.res 2
spinflag:
	.res 1
xcentercoord:
	.res 2
ycentercoord:
	.res 2
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
InitPlasma:	; ...and spaceplane...
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	ldx	#0000h			; change this to move entire screen X, Y
	stx	plasmahscrpos		; horizontal screen position
	stx	plasmavscrpos		; vertical screen position

	stx	HDMAoffset1
	stx	HDMAoffset2
	stx	HDMAdis1
	stx	HDMAdis2
	stx	blendbrightoffset
	stx	blendflip
	stx	blendflip2

	stx	map_xpos		; spaceplane x
	stx	map_ypos		; spaceplane y

	stx	matrixaoffset		; Matrix A offset

	stx	storage5
	inx
	stx	storage2		; assumes 1
	inx
	inx
	stx	blendbitsoffset		; assumes 3

        ldx	#%10101111
        stx	blend2131

	stz	spinflag
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
ResetPlasmaCoord:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	ldx	#0080h			; default 80
	stx	xcentercoord		; X center coordinate position
	ldx	#0070h			; default 70
	stx	ycentercoord		; Y center coordinate position
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
ResetPlasmaCoord2:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	ldx	#0100h
	stx	matrixdcos		; offset for COS data (Matrix D)
	lda	#01h
	sta	plasma_bar
	rts


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
;                    Blend Color Change Effect Routine
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
ColorBlend:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	blendflip2
	eor	#255
	sta	blendflip2
	beq	blendotherhalf
;-------------------------------------------------------------------------;
	rts
;-------------------------------------------------------------------------;
blendotherhalf:
;-------------------------------------------------------------------------;
	ldx	blendbrightoffset
	lda	BLEND_BRIGHT,x
	ldx	blendbitsoffset
	ora	BLEND_BITS,x
	sta	REG_COLDATA
	lda	blendbrightoffset
	inc a
	and	#3fh
	sta	blendbrightoffset
	beq	blend2131flip
;-------------------------------------------------------------------------;
	rts
;-------------------------------------------------------------------------;
blend2131flip:
;-------------------------------------------------------------------------;
	lda	blend2131
	eor	#80h
	sta	blend2131
	sta	REG_CGADSUB
	lda	blendflip
	eor	#255
	sta	blendflip
	beq	blendotherhalf2
;-------------------------------------------------------------------------;
	rts
;-------------------------------------------------------------------------;
blendotherhalf2:
;-------------------------------------------------------------------------;
	lda	blendbitsoffset
	inc a
	and	#03h
	sta	blendbitsoffset
	rts
	

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
;                    Start HDMA routine to setup plane on/off HDMA
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
PlasmaHDMAMover:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	ldx	HDMAdis1
	inx
	cpx	#0200h
	bne	HDMAdis1ok
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
HDMAdis1ok:
;-------------------------------------------------------------------------;
	stx	HDMAdis1
	ldx	HDMAdis2
	inx
	inx
	cpx	#0200h
	bne	HDMAdis2ok
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
HDMAdis2ok:
;-------------------------------------------------------------------------;
	stx	HDMAdis2

	rep	#30h

	lda	HDMAdis1
	asl a
	clc
	adc	HDMAdis1
	sta	Storage

	lda	Storage
	clc
	adc	#0000h
	sta	REG_A1T0L
	sta	REG_A1T2L

	lda	HDMAdis2
	asl a
	clc
	adc	HDMAdis2
	sta	Storage

	lda	Storage
	clc
	adc	#<COLOR_RAM
	sta	(color_ptr)

	sep	#20h

	rts


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
;                    HDMA setup routine
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
PlasmaOnlyHDMA:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	#DMAP_XFER_MODE_2
	sta	REG_DMAP0		; 0= 1 byte per register (not a word!)
	sta	REG_DMAP1
	sta	REG_DMAP2

	lda	#<REG_M7A
	sta	REG_BBAD0
	ldx	#<PLASMAHDMACOLADDR	; the address of where it's located
	stx	REG_A1T0L
	lda	#^PLASMAHDMACOLADDR
	sta	REG_A1B0		; bank address of data in ram

	lda	#<REG_M7C		; Matrix B
	sta	REG_BBAD1
	ldx	#<COLOR_RAM		; the colors will be at $7f8000!!
	stx	REG_A1T1L
	lda	#^COLOR_RAM
	sta	REG_A1B1

	lda	#<REG_M7B
	sta	REG_BBAD2		; 21xx   this is 211b (Matrix A)
	ldx	#<PLASMAHDMACOLADDR	; the address of where it's located
	stx	REG_A1T2L
	lda	#^PLASMAHDMACOLADDR
	sta	REG_A1B2		; bank address of data in ram

	rts


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
PlasmaMapHDMA:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	#DMAP_XFER_MODE_2
	sta	REG_DMAP1
	lda	#<REG_M7A
	sta	REG_BBAD1
	ldx	#<PLASMAHDMACOLADDR
	stx	REG_A1T1L
	lda	#^PLASMAHDMACOLADDR
	sta	REG_A1B1

	rts


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
;                     Start Of Mode 7 Routine
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
PlasmaMode7:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	ldy	matrixaoffset		; get sine offset spin

	;rep	#20h			; A = 16 bit

	;lda	plasma_sine_addr1	; get address of sine data
	;clc
	;adc	matrixacos		; add Matrix A offset
	;sta	plasma_sine_addr2
	;lda	(plasma_sine_addr2),y	; read 16 bit word of COS data

	;sep	#20h			; A = 8 bit

	;sta	REG_M7A			; store first 8 bit into Matrix A register
	;xba				; exchange bytes (like swap) to get the other 8 bits
	;sta	REG_M7A			; store it

	;rep	#20h			; A = 16 bit

	;lda	plasma_sine_addr1	; get address of sine data
	;clc
	;adc	matrixbsin		; add Matrix B offset
	;sta	plasma_sine_addr2
	;lda	(plasma_sine_addr2),y		; read 16 bit word of SIN data

	;sep	#20h			; A = 8 bit

	;sta	REG_M7B			; store into Matrix B register
	;xba				; swap lo-hi bytes
	;sta	REG_M7B			; store it 

	;rep	#20h			; A = 16 bit

	;lda	plasma_sine_addr1	; get address of sine data
	;clc
	;adc	marrixcsin		; add Matrix C offset
	;sta	plasma_sine_addr2
	;lda	(plasma_sine_addr2),y		; read 16 bit word of -SIN data
	;sep	#20h			; A = 8 bit 

	;sta	REG_M7C			; store into Matrix C register
	;xba				; swap lo-hi bytes
	;sta	REG_M7C			; store it

	rep	#20h			; A = 16 bit

	lda	plasma_sine_addr1	; get address of sine data
	clc
	adc	matrixdcos		; add Matrix D offset
	sta	plasma_sine_addr2
	lda	(plasma_sine_addr2),y	; read 16 bit word of COS data

	sep	#20h			; A = 8 bit

	sta	REG_M7D			; store into Matrix D register
	xba				; swap lo-hi bytes
	sta	REG_M7D			; store it

	lda	xcentercoord		;8
	sta	REG_M7X
	lda	xcentercoord+1		; X center co-ordinate
	sta	REG_M7X

	lda	ycentercoord		; a
	sta	REG_M7Y
	lda	ycentercoord+1		; center co-ordinate
	sta	REG_M7Y

	lda	plasmahscrpos
	sta	REG_BG1HOFS
	lda	plasmahscrpos+1		; X screen position
	sta	REG_BG1HOFS

	lda	plasmavscrpos
	sta	REG_BG1VOFS
	lda	plasmavscrpos+1		; Y screen position
	sta	REG_BG1VOFS

	lda	spinflag	
	beq	Spinsine
;-------------------------------------------------------------------------;
	rts
;-------------------------------------------------------------------------;
Spinsine:
;-------------------------------------------------------------------------;
	rep	#20h

	lda	matrixaoffset
	clc
	adc	#0002h
	cmp	#0400h
	bne	noclear
;-------------------------------------------------------------------------;
	lda	#0000h
;-------------------------------------------------------------------------;
noclear:
;-------------------------------------------------------------------------;
	sta	matrixaoffset

	sep	#20h

	rts


;==========================================================================
;       	     SETUP ROUTINES FOR PROGRAM
;==========================================================================

;==========================================================================
;                         Copy graf-x data
;==========================================================================


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
CopyPlasmaGfx:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	ldx	#0ffffh			; We'll generate the Plasmascreen
	bra	ResetAY			; data here rather than storing it
;---------------------------------------; in ROM which would take 512 bytes
:	sta	PLASMA_MAP,x		; this way we can save 471 bytes
	cpy	#0000h
	bne	DecreaseTile
;-------------------------------------------------------------------------;
	cmp	#3fh			; check max tile
	bne	IncreaseTile
;-------------------------------------------------------------------------;
RequestTileDecrease:
;-------------------------------------------------------------------------;
	ldy	#0001h
	dea	; negate upcoming increase
;-------------------------------------------------------------------------;
IncreaseTile:
;-------------------------------------------------------------------------;
	ina
	bra	IncreaseIndex
;-------------------------------------------------------------------------;
DecreaseTile:
;-------------------------------------------------------------------------;
	dea
;-------------------------------------------------------------------------;
	cmp	#0ffh			; check min tile
	bne	IncreaseIndex
;-------------------------------------------------------------------------;
ResetAY:
;-------------------------------------------------------------------------;
	lda	#0
	ldy	#0000h
;-------------------------------------------------------------------------;
IncreaseIndex:
;-------------------------------------------------------------------------;
	inx
	cpx	#0200h
	bne	:-
;-------------------------------------------------------------------------;
	ldx	#0000h
	stx	REG_VMADDL
	txy
	lda	#3fh
;-------------------------------------------------------------------------;
CopyChars:
;-------------------------------------------------------------------------;
	sta	REG_VMDATAH
	iny
	cpy	#0040h
	bne	CopyChars		; set up plasma gfx
;-------------------------------------------------------------------------;
	ldy	#0000h
	dec a
	and	#3fh
	inx
	cpx	#0040h
	bne	CopyChars
;-------------------------------------------------------------------------;
MakeTiles:
;-------------------------------------------------------------------------;
	stz	REG_VMAIN		; putting #$00 into REG_VMAIN will
	ldx	#0000h			; increase the VRAM address when writing
	stx	REG_VMADDL		; to REG_VMDATAL
	stx	Storage
	stx	Storage2
	txy
;-------------------------------------------------------------------------;
clearscreen:
;-------------------------------------------------------------------------;
	ldx	Storage
	lda	PLASMA_MAP,x
	sta	REG_VMDATAL		; Draw Plasma tiles
	inc	Storage
	lda	Storage2
	inc a
	and	#7fh
	sta	Storage2
	bne	NoIncPlasma
	lda	Storage
	and	#7fh
	inc a
	sta	Storage
;-------------------------------------------------------------------------;
NoIncPlasma:
;---------------------------------------;---------------------------------;
	iny				;
	cpy	#4000h			; Mode 7 uses a 128*128 tile screen
	bne	clearscreen		; 128*128 = 16384 = $4000
;---------------------------------------;---------------------------------;
	DoCopyPalette PLASMA_COLORS, 0, 64

	ldx	#PLASMA_SINE
	stx	plasma_sine_addr1
	stx	plasma_sine_addr2
;-------------------------------------------------------------------------;
;                        Set up HDMA tables in RAM
;-------------------------------------------------------------------------;
	ldy	#0000h
	sty	Storage

	ldx	HDMAoffset1
	stx	Storage2
;-------------------------------------------------------------------------;
CopyHDMAcolse:
;-------------------------------------------------------------------------;
	ldx	Storage
	lda	#01h
	sta	PLASMAHDMACOLADDR,x		; length of bar
	inx
	stx	Storage
	
	ldx	Storage2
	lda	PLASMA_SINE,x			; first byte of color
	inx
	stx	Storage2
	
	ldx	Storage
	sta	PLASMAHDMACOLADDR,x		
	inx
	stx	Storage
	
	ldx	Storage2
	lda	PLASMA_SINE,x			; second byte of color
	inx
	stx	Storage2
	
	ldx	Storage
	sta	PLASMAHDMACOLADDR,x
	inx
	stx	Storage
	
	ldx	HDMAoffset1
	inx
	inx
	inx
	inx
	cpx	#0400h
	bne	noresetHDMAoffsete
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
noresetHDMAoffsete:
;-------------------------------------------------------------------------;
	stx	HDMAoffset1
	iny
	cpy	#1800h
	bne	CopyHDMAcolse
;-------------------------------------------------------------------------;
	ldy	#0000h
	sty	Storage
	ldx	HDMAoffset2
	stx	Storage2
;-------------------------------------------------------------------------;
CopyHDMAcols2f:
;-------------------------------------------------------------------------;
	ldx	Storage
	lda	#01h
	sta	COLOR_RAM,x		; length of bar
	inx
	stx	Storage
	
	ldx	Storage2
	lda	PLASMA_SINE,x			; first byte of color
	inx
	stx	Storage2
	
	ldx	Storage
	sta	COLOR_RAM,x		
	inx
	stx	Storage
	
	ldx	Storage2
	lda	PLASMA_SINE,x			; second byte of color
	inx
	stx	Storage2
	
	ldx	Storage
	sta	COLOR_RAM,x
	inx
	stx	Storage
	
	ldx	HDMAoffset2
	inx
	inx
	cpx	#0400h
	bne	noresetHDMAoffsetf
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
noresetHDMAoffsetf:
;-------------------------------------------------------------------------;
	stx	HDMAoffset2
	iny
	cpy	#1800h
	bne	CopyHDMAcols2f
;-------------------------------------------------------------------------;
	rts


;/////////////////////////////////////////////////////////////////////////;
.segment "DATA"
;/////////////////////////////////////////////////////////////////////////;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
BLEND_BITS:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	%00100000,%00000000,%10000000,%10100000
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
BLEND_BRIGHT:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$00,$01,$02,$03,$04,$05,$06,$07
	.byte	$08,$09,$0a,$0b,$0c,$0d,$0e,$0f
	.byte	$10,$11,$12,$13,$14,$15,$16,$17
	.byte	$18,$19,$1a,$1b,$1c,$1d,$1e,$1f
	.byte	$1f,$1e,$1d,$1c,$1b,$1a,$19,$18
	.byte	$17,$16,$15,$14,$13,$12,$11,$10
	.byte	$0f,$0e,$0d,$0c,$0b,$0a,$09,$08
	.byte	$07,$06,$05,$04,$03,$02,$01,$00
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
PLASMA_COLORS:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$0180,$01C0,$05E0,$0600,$0A20,$0E40,$1280,$12A0
	.word	$16C0,$1AE0,$1F00,$2720,$2B60,$2F80,$37A0,$3BC0

	.word	$43E0,$47A0,$4B60,$4F20,$52E0,$56A0,$5A60,$5E20
	.word	$61C0,$6580,$6940,$6D00,$70C0,$7480,$7840,$7C00

	.word	$7442,$6C84,$64C6,$5D08,$554A,$4D8C,$45CE,$4210
	.word	$3A31,$3273,$2AB5,$22F7,$1B39,$137B,$0BBD,$03FF

	.word	$03BF,$037F,$033F,$02FF,$02BF,$027F,$023F,$021F
	.word	$01DF,$019F,$015F,$011F,$00DF,$009F,$005F,$001F
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
PLASMA_SINE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
 .word  128,131,134,137,140,144,147,150,153,156,159,162,165,168,171
 .word  174,177,179,182,185,188,191,193,196,199,201,204,206,209,211
 .word  213,216,218,220,222,224,226,228,230,232,234,235,237,239,240
 .word  241,243,244,245,246,248,249,250,250,251,252,253,253,254,254
 .word  254,255,255,255,255,255,255,255,254,254,254,253,253,252,251
 .word  250,250,249,248,246,245,244,243,241,240,239,237,235,234,232
 .word  230,228,226,224,222,220,218,216,213,211,209,206,204,201,199
 .word  196,193,191,188,185,182,179,177,174,171,168,165,162,159,156
 .word  153,150,147,144,140,137,134,131,128,125,122,119,116,112,109
 .word  106,103,100,97,94,91,88,85,82,79,77,74,71,68,65,63,60,57,55
 .word  52,50,47,45,43,40,38,36,34,32,30,28,26,24,22,21,19,17,16,15
 .word  13,12,11,10,8,7,6,6,5,4,3,3,2,2,2,1,1,1,1,1,1,1,2,2,2,3,3,4
 .word  5,6,6,7,8,10,11,12,13,15,16,17,19,21,22,24,26,28,30,32,34,36
 .word  38,40,43,45,47,50,52,55,57,60,63,65,68,71,74,77,79,82,85,88
 .word  91,94,97,100,103,106,109,112,116,119,122,125

 .word  128,131,134,137,140,144,147,150,153,156,159,162,165,168,171
 .word  174,177,179,182,185,188,191,193,196,199,201,204,206,209,211
 .word  213,216,218,220,222,224,226,228,230,232,234,235,237,239,240
 .word  241,243,244,245,246,248,249,250,250,251,252,253,253,254,254
 .word  254,255,255,255,255,255,255,255,254,254,254,253,253,252,251
 .word  250,250,249,248,246,245,244,243,241,240,239,237,235,234,232
 .word  230,228,226,224,222,220,218,216,213,211,209,206,204,201,199
 .word  196,193,191,188,185,182,179,177,174,171,168,165,162,159,156
 .word  153,150,147,144,140,137,134,131,128,125,122,119,116,112,109
 .word  106,103,100,97,94,91,88,85,82,79,77,74,71,68,65,63,60,57,55
 .word  52,50,47,45,43,40,38,36,34,32,30,28,26,24,22,21,19,17,16,15
 .word  13,12,11,10,8,7,6,6,5,4,3,3,2,2,2,1,1,1,1,1,1,1,2,2,2,3,3,4
 .word  5,6,6,7,8,10,11,12,13,15,16,17,19,21,22,24,26,28,30,32,34,36
 .word  38,40,43,45,47,50,52,55,57,60,63,65,68,71,74,77,79,82,85,88
 .word  91,94,97,100,103,106,109,112,116,119,122,125

 .word  128,131,134,137,140,144,147,150,153,156,159,162,165,168,171
 .word  174,177,179,182,185,188,191,193,196,199,201,204,206,209,211
 .word  213,216,218,220,222,224,226,228,230,232,234,235,237,239,240
 .word  241,243,244,245,246,248,249,250,250,251,252,253,253,254,254
 .word  254,255,255,255,255,255,255,255,254,254,254,253,253,252,251
 .word  250,250,249,248,246,245,244,243,241,240,239,237,235,234,232
 .word  230,228,226,224,222,220,218,216,213,211,209,206,204,201,199
 .word  196,193,191,188,185,182,179,177,174,171,168,165,162,159,156
 .word  153,150,147,144,140,137,134,131,128,125,122,119,116,112,109
 .word  106,103,100,97,94,91,88,85,82,79,77,74,71,68,65,63,60,57,55
 .word  52,50,47,45,43,40,38,36,34,32,30,28,26,24,22,21,19,17,16,15
 .word  13,12,11,10,8,7,6,6,5,4,3,3,2,2,2,1,1,1,1,1,1,1,2,2,2,3,3,4
 .word  5,6,6,7,8,10,11,12,13,15,16,17,19,21,22,24,26,28,30,32,34,36
 .word  38,40,43,45,47,50,52,55,57,60,63,65,68,71,74,77,79,82,85,88
 .word  91,94,97,100,103,106,109,112,116,119,122,125

 .word  128,131,134,137,140,144,147,150,153,156,159,162,165,168,171
 .word  174,177,179,182,185,188,191,193,196,199,201,204,206,209,211
 .word  213,216,218,220,222,224,226,228,230,232,234,235,237,239,240
 .word  241,243,244,245,246,248,249,250,250,251,252,253,253,254,254
 .word  254,255,255,255,255,255,255,255,254,254,254,253,253,252,251
 .word  250,250,249,248,246,245,244,243,241,240,239,237,235,234,232
 .word  230,228,226,224,222,220,218,216,213,211,209,206,204,201,199
 .word  196,193,191,188,185,182,179,177,174,171,168,165,162,159,156
 .word  153,150,147,144,140,137,134,131,128,125,122,119,116,112,109
 .word  106,103,100,97,94,91,88,85,82,79,77,74,71,68,65,63,60,57,55
 .word  52,50,47,45,43,40,38,36,34,32,30,28,26,24,22,21,19,17,16,15
 .word  13,12,11,10,8,7,6,6,5,4,3,3,2,2,2,1,1,1,1,1,1,1,2,2,2,3,3,4
 .word  5,6,6,7,8,10,11,12,13,15,16,17,19,21,22,24,26,28,30,32,34,36
 .word  38,40,43,45,47,50,52,55,57,60,63,65,68,71,74,77,79,82,85,88
 .word  91,94,97,100,103,106,109,112,116,119,122,125
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
PLASMAX:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	00,00,00,01,02,02,03,04,06,07,08,09,10,12,13,14
	.byte	14,15,16,16,16,16,16,15,14,14,13,12,10,09,08,07
	.byte	06,04,03,02,02,01,00,00,00,00,01,02,03,05,07,08
	.byte	09,10,10,10,09,08,07,05,03,02,01,00,00,00,01,02
	.byte	03,05,07,09,11,13,15,17,18,19,20,20,20,20,20,20
	.byte	21,21,21,22,22,23,24,24,25,26,27,28,28,29,30,31
	.byte	31,32,33,33,34,34,34,35,35,35,35,35,35,35,34,34
	.byte	33,32,32,31,30,29,28,27,25,24,23,22,20,19,18,16
	.byte	15,13,12,11,10,08,07,06,05,04,03,03,02,01,01,00
	.byte	00,00,255
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
