;-------------------------------------------------------------------------;
.include "bg_scrolltext.inc"
.include "brr.inc"
.include "graphics.inc"
.include "intro.inc"
.include "options.inc"
.include "shadow_ram.inc"
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_joypad.inc"
.include "snes_zvars.inc"
.include "snesmod.inc"
.include "soundbank.inc"
;-------------------------------------------------------------------------;
.import FadeMosaic, SuperResetStuff, main
;-------------------------------------------------------------------------;
.export DoIntro
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
MAX_BRIGHTNESS = 15	; 0-15
OPT = 0a000h
CENTER_HEIGHT = 16
PLASMA_HEIGHT = 96
SCROLL_VPOS = 2
;-------------------------------------------------------------------------;

;-------------------------------------------------------------------------;
RAM_100		=	0400h
RAM_200		=	0500h
RAM_PAL_RED	=	0600h
RAM_PAL_GREEN	=	0700h
RAM_PAL_BLUE	=	0800h
RAM_CGDATA	=	0900h
RAM_BG13HOFS	=	0b00h
RAM_BG2VOFS	=	0d00h
RAM_BG1MAP	=	0e00h
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
bg2 = m0
bg2lines = m2
bot_bg2list_index = m3
bot_bg2vofs = m5
max_bg2vofs = m6
temp = m7
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.bss
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
bg1_sine_index:
	.res 1
pal_index:
	.res 2
pal_index_start:
	.res 1
pal_sine1:
	.res 1
pal_sine2:
	.res 1
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.segment "XCODE"
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
DoIntro:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	DoDecompressDataVram gfx_scroll32Tiles, SCROLLGFX*2
	DoDecompressDataVram gfx_logoTiles, LOGOGFX*2
	DoDecompressDataVram gfx_logoMap, LOGOMAP*2

	DoDecompressDataVram gfx_8x8_last_duelTiles, BG4GFX*2

	DoDecompressDataVram gfx_loadingTiles, LOADGFX*2
	DoDecompressDataVram gfx_loadingMap, LOADMAP*2

	lda	#VMAIN_INCH
	sta	REG_VMAIN

	ldx	#BG4MAP
	stx	REG_VMADDL

	ldx	#0000h
:	lda	TEXT,x
	clc
	adc	#60h
	sta	REG_VMDATAL
	lda	#PALETTE2
	sta	REG_VMDATAH
	inx
	cpx	#32*32
	bne	:-

	DoCopyPalette gfx_logoPal, 4, 4
	DoCopyPalette gfx_8x8_last_duelPal, 8,4
	DoCopyPalette gfx_loadingPal, 16, 4

	jsr	Setup
	ldx	#SCROLLTEXT
	ldy	#SCROLLMAP+1ffh
	jsr	SetupBGScrolltext

	lda	#DMAP_XFER_MODE_2
	sta	REG_DMAP0
	sta	REG_DMAP2
	sta	REG_DMAP6
	dea
	sta	REG_DMAP5

	lda	#<REG_BG1HOFS
	sta	REG_BBAD0
	ldx	#RAM_BG13HOFS
	stx	REG_A1T0L
	stz	REG_A1B0

	stz	REG_DMAP1
	lda	#<REG_BG12NBA
	sta	REG_BBAD1
	ldx	#LIST_BG12NBA
	stx	REG_A1T1L
	stz	REG_A1B1

	lda	#<REG_BG2VOFS
	sta	REG_BBAD2
	ldx	#RAM_BG2VOFS-6
	stx	REG_A1T2L
	stz	REG_A1B2

	stz	REG_DMAP3
	lda	#<REG_CGADSUB
	sta	REG_BBAD3
	ldx	#LIST_CGADSUB
	stx	REG_A1T3L
	stz	REG_A1B3

	lda	#<REG_BG2SC
	sta	REG_BBAD5
	ldx	#LIST_BGSC
	stx	REG_A1T5L
	stz	REG_A1B5

	lda	#<REG_BG2HOFS
	sta	REG_BBAD6
	ldx	#RAM_BG2HOFS
	stx	REG_A1T6L
	stz	REG_A1B6

	ldx	#(BRR_ORDER_END-BRR_ORDER)
	stx	song_cmp

	jsr	spcBoot
;---------------------------------------;---------------------------------;
	lda	#^__SOUNDBANK__		; give soundbank
	jsr	spcSetBank		; (the soundbank must have dedicated bank(s))
;---------------------------------------;---------------------------------;
	lda	#36			; allocate 36*256 bytes
	jsr	spcAllocateSoundRegion	; for streaming samples
;---------------------------------------;---------------------------------;
	lda	#^SOUNDTABLE|80h	; set sound table address
	ldy	#.LOWORD(SOUNDTABLE)	;
	jsr	spcSetSoundTable	;
;---------------------------------------;---------------------------------;
	ldx	#MOD_INPUT
	jsr	spcLoad
	ldx	#0
	stx	brr_index
	jsr	spcPlay
	jsr	spcFlush

	inc	RAM_BG2VOFS-3

	lda	#80h
	sta	REG_INIDISP

	lda	#TM_BG2|TM_BG4
	sta	REG_TM
	dea
	sta	REG_TS

	lda	#01h
	sta	REG_CGADD

	ldx	#0
;---------------------------------------;
:	lda	PAL,x
	sta	REG_CGDATA
	inx
	lda	PAL,x
	sta	REG_CGDATA
	inx
	cpx	#6
	bne	:-
;---------------------------------------;
	lda	#%01101111
	sta	REG_HDMAEN

	lda	#NMI_ON|NMI_JOYPAD
	sta	REG_NMITIMEN

:	lda	REG_RDNMI
	bpl	:-

;=========================================================================;
Loopy:
;=========================================================================;
	lda	REG_RDNMI
	bpl	Loopy
;---------------------------------------;
	jsr	FadeMosaic
	lda	reg_inidisp
	beq	End

	lda	#16*2
	sta	REG_CGADD

	lda	#DMAP_XFER_MODE_2
	sta	REG_DMAP4
	lda	#<REG_CGDATA
	sta	REG_BBAD4
	ldx	#RAM_CGDATA
	stx	REG_A1T4L
	stz	REG_A1B4
	ldx	#0100h
	stx	REG_DAS4L
	lda	#10h
	sta	REG_MDMAEN

	ldx	#BG3MAP
	stx	REG_VMADDL

	lda	#DMAP_XFER_MODE_1
	sta	REG_DMAP4
	lda	#<REG_VMDATA
	sta	REG_BBAD4
	ldx	#RAM_BG1MAP
	stx	REG_A1T4L
	stz	REG_A1B4
	ldx	#0040h
	stx	REG_DAS4L
	lda	#10h
	sta	REG_MDMAEN

	jsr	BGScrolltext

	lda	joy1_held
	ora	joy2_held
	ora	joy1_held+1
	ora	joy2_held+1
	bne	:+
;---------------------------------------;
	jsr	BGScrolltext
;---------------------------------------;
:	jsr	BG1
	jsr	MoveCenter
	jsr	StreamAudio

	lda	bg2
	eor	#255
	sta	bg2
	beq	:+
;---------------------------------------;
	jsr	MoveBG2
	bra	Loopy
;---------------------------------------;
:	jsr	Plasma
	bra	Loopy
End:	jsr	SuperResetStuff
	rts


;=========================================================================;
MoveCenter:
;=========================================================================;
	ldx	brr_index
	lda	CENTER,x
	sta	RAM_BG2VOFS-2
	rts


;=========================================================================;
Setup:
;=========================================================================;
	lda	#BGMODE_4
	sta	REG_BGMODE

	lda	#BG1MAP>>8
	sta	REG_BG1SC

	lda	#LOADMAP>>8
	sta	REG_BG2SC

	lda	#BG4MAP>>8
	sta	REG_BG4SC

	lda	#LOADGFX>>8+NULMAP>>12
	sta	REG_BG12NBA

	lda	#BG4GFX>>8
	sta	REG_BG34NBA

	lda	#0e0h
	sta	REG_COLDATA
	lda	#02h
	sta	REG_CGSWSEL

	lda	#TM_BG2
	sta	REG_TM

	lda	#PLASMA_HEIGHT+CENTER_HEIGHT
	sta	RAM_BG2HOFS
	stz	RAM_BG2HOFS+1
	stz	RAM_BG2HOFS+2
	stz	RAM_BG2HOFS+5
	stz	RAM_BG2HOFS+6

	lda	#PLASMA_HEIGHT
	sta	RAM_BG2VOFS-6

	lda	#CENTER_HEIGHT
	sta	RAM_BG2VOFS-3

	lda	#0feh
	sta	RAM_BG2VOFS-5

	lda	#09fh
	sta	RAM_BG2VOFS-2			; center text vpos
	stz	RAM_BG2VOFS-4
	stz	RAM_BG2VOFS-1

	lda	#1
	sta	RAM_BG2HOFS+3
;-------------------------------------------------------------------------;
MakeBG1Map:					;   by Alfatech/Censor
;-------------------------------------------------------------------------;
	ldx	#BG1MAP
	stx	REG_VMADDL
	ldx	#0000h
	txy
	lda	#00h
;-------------------------------;
:	sta	REG_VMDATAL	;
	stz	REG_VMDATAH	;
	inx			;
	cpx	#0020h		;
	bne	:-		;
;-------------------------------;
	ldx	#0000h
	ina
	cmp	#10h
	bne	:-
;-------------------------------------------------------------------------;
	lda	#00h
	iny
	cpy	#2
	bne	:-
;-------------------------------------------------------------------------;
	ldx	#BG1GFX
	stx	REG_VMADDL
	lda	#20h
	sta	temp
	ldx	#0000h
;-------------------------------------------------------------------------;
MakeBG1Graphics:				;   by Alfatech/Censor
;-------------------------------------------------------------------------;
	ldy	#0000h
noresy:	lda	temp
	and	#01h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS,y
	lda	temp
	and	#02h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS+01h,y
	lda	temp
	and	#04h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS+10h,y
	lda	temp
	and	#08h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS+11h,y
	lda	temp
	and	#10h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS+20h,y
	lda	temp
	and	#20h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS+21h,y
	lda	temp
	and	#40h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS+30h,y
	lda	temp
	and	#80h
	beq	:+

	lda	#0ffh
	bra	:++

:	lda	#00h
:	sta	RAM_BG13HOFS+31h,y
	inc	temp
	iny
	iny
	cpy	#0010h
	beq	:+

	jmp	noresy

:	ldy	#0000h
:	lda	RAM_BG13HOFS,y
	sta	REG_VMDATAL
	iny
	lda	RAM_BG13HOFS,y
	sta	REG_VMDATAH
	iny
	cpy	#0040h
	bne	:-

	inx
	cpx	#0010h
	beq	:+

	jmp	MakeBG1Graphics
;-------------------------------------------------------------------------;
:	dec	RAM_BG13HOFS
	lda	#0fh
	sta	REG_INIDISP

	ldx	#0000h
	txy
:	lda	#01h
	sta	REG_M7A
	stz	REG_M7A
	lda	BG1_COLOR,y
	sta	REG_M7B
	lda	REG_MPYL
	sta	RAM_PAL_RED,x
	lda	REG_MPYM
	sta	RAM_PAL_RED+01h,x

	lda	#20h
	sta	REG_M7A
	stz	REG_M7A
	lda	BG1_COLOR,y
	sta	REG_M7B
	lda	REG_MPYL
	sta	RAM_PAL_GREEN,x
	lda	REG_MPYM
	sta	RAM_PAL_GREEN+01h,x

	stz	REG_M7A
	lda	#04h
	sta	REG_M7A
	lda	BG1_COLOR,y
	sta	REG_M7B
	lda	REG_MPYL
	sta	RAM_PAL_BLUE,x
	lda	REG_MPYM
	sta	RAM_PAL_BLUE+01h,x
	inx
	inx
	iny
	cpy	#0080h
	bne	:-
;-------------------------------------------------------------------------;
	jsr	BG1Palette

	stz	pal_sine1

	lda	#5ch
	sta	pal_index_start

	lda	#0b6h
	sta	pal_sine1

	ldx	#00d6h
	stx	RAM_100+20h
	ldx	#0000h
	stx	RAM_100+22h
	stx	RAM_100+28h
	ldx	#01d6h
	stx	RAM_100+24h
	stx	RAM_100+26h

	rts


;=========================================================================;
BG1:						;   by Alfatech/Censor
;=========================================================================;
	rep	#30h

	lda	RAM_100+28h
	sec
	sbc	#0002h
	bpl	:+
;-------------------------------------------------------------------------;
	clc
	adc	#02d0h
:	sta	RAM_100+28h

	lda	RAM_100+20h
	sta	RAM_100+22h
	lda	RAM_100+24h
	sta	RAM_100+26h
	ldy	#0000h
	sty	RAM_100+10h
;-------------------------------------------------------------------------;
:	ldx	RAM_100+22h
	lda	BG13HOFS_SINE,x
	and	#00ffh
	ldx	RAM_100+26h
	clc
	adc	LIST_BG13HOFS,x
	sta	RAM_BG13HOFS+01h,y
	inc	RAM_100+22h
	inc	RAM_100+26h
	inc	RAM_100+26h
	iny
	iny
	inc	RAM_100+10h
	lda	RAM_100+10h
	cmp	#127
	bne	:-
;-------------------------------------------------------------------------;
	sep	#20h

	lda	#225
	sta	RAM_BG13HOFS+01h,y
	iny

	rep	#30h

	stz	RAM_100+10h
;-------------------------------------------------------------------------;
:	ldx	RAM_100+22h
	lda	BG13HOFS_SINE,x
	and	#00ffh
	ldx	RAM_100+26h
	clc
	adc	LIST_BG13HOFS,x
	sta	RAM_BG13HOFS+01h,y
	inc	RAM_100+22h
	inc	RAM_100+26h
	inc	RAM_100+26h
	iny
	iny
	inc	RAM_100+10h
	lda	RAM_100+10h
	cmp	#97
	bne	:-
;-------------------------------------------------------------------------;
	lda	#0000h
	sta	RAM_BG13HOFS+01h,y
	lda	RAM_100+20h
	clc
	adc	#0002h
	cmp	#169
	bcc	:+
;-------------------------------------------------------------------------;
	lda	RAM_100+20h
	sec
	sbc	#169
;-------------------------------------------------------------------------;
:	sta	RAM_100+20h
	lda	RAM_100+24h
	sec
	sbc	#0006h
	bpl	BG1Palette
;-------------------------------------------------------------------------;
	lda	#01d6h
	clc
	adc	RAM_100+24h
;-------------------------------------------------------------------------;
	sta	RAM_100+24h
;-------------------------------------------------------------------------;
BG1Palette:					;   by Alfatech/Censor
;-------------------------------------------------------------------------;
	sep	#30h

	inc	pal_sine1
	ldx	pal_sine1
	lda	SINE_OF_DOOM,x
	and	#0feh
	tax
	ldy	#00h
;---------------------------------------;
:	lda	RAM_PAL_RED,x
	sta	RAM_CGDATA,y
	inx
	iny
	bne	:-
;---------------------------------------;
	ldx	pal_index_start
	and	#0feh
	tax
	stx	pal_index
	ldx	pal_sine2
	lda	SINE_OF_DOOM,x
	and	#0feh
	tax
	stx	pal_index+1
	ldy	#00h
;---------------------------------------;
:	lda	RAM_CGDATA,y
	ldx	pal_index
	ora	RAM_PAL_GREEN,x
	ldx	pal_index+1
	ora	RAM_PAL_BLUE,x
	sta	RAM_CGDATA,y
	lda	RAM_CGDATA+01h,y
	ora	RAM_PAL_BLUE+01h,x
	ldx	pal_index
	ora	RAM_PAL_GREEN+01h,x
	sta	RAM_CGDATA+01h,y
	inx
	inx
	stx	pal_index
	ldx	pal_index+1
	inx
	inx
	stx	pal_index+1
	iny
	iny
	bne	:-
;---------------------------------------;
	inc	pal_index_start
	inc	pal_sine1

	rep	#10h

	rts


;=========================================================================;
MoveBG2:					;   by Alfatech/Censor
;=========================================================================;
	lda	bot_bg2list_index
	clc
	adc	#40h
	sta	max_bg2vofs

	lda	#SCROLL_VPOS
	sta	bot_bg2vofs

	ldx	bot_bg2list_index
	ldy	#0000h
;---------------------------------------;
:	lda	BG2_LINES,x
	sta	bg2lines
;---------------------------------------;
:	lda	bg2lines
	beq	:+
;---------------------------------------;
	dec	bg2lines

	rep	#30h

	lda	bot_bg2vofs
	sta	RAM_BG2VOFS+01h,y

	sep	#20h

	iny
	iny
	dec	bot_bg2vofs
	bra	:-
;---------------------------------------;
:	inc	bot_bg2vofs
	inx
	cpx	max_bg2vofs
	bne	:---
;---------------------------------------;
	tya
	lsr a
	clc
	adc	#80h
	sta	RAM_BG2VOFS
	lda	#20h
	sta	RAM_BG2VOFS+01h,y
	lda	#00h
	sta	RAM_BG2VOFS+02h,y
	sta	RAM_BG2VOFS+03h,y
	sta	RAM_BG2VOFS+04h,y
	inc	bot_bg2list_index
	lda	bot_bg2list_index
	cmp	#30h
	bne	:+
;---------------------------------------;
	stz	bot_bg2list_index
;---------------------------------------;
:	rts


;=========================================================================;
Plasma:						;   by Alfatech/Censor
;=========================================================================;
	rep	#30h

	lda	RAM_100+28h
	sta	RAM_100+2ah

	lda	#VMAIN_INCH
	sta	REG_VMAIN

	ldx	#BG3MAP
	stx	REG_VMADDL

	ldx	#0000h
;---------------------------------------;
:	ldy	RAM_100+22h
	lda	BG13HOFS_SINE,y
	and	#00ffh
	ldy	RAM_100+2ah
	clc
	adc	LIST_BG1MAP,y
	eor	#OPT
	sta	RAM_BG1MAP,x
	inc	RAM_100+22h
	lda	RAM_100+2ah
	clc
	adc	#0004h
	sta	RAM_100+2ah
	inx
	inx
	cpx	#0040h
	bne	:-
;---------------------------------------;
	dec	RAM_100+22h
	lda	RAM_100+2ah
	sec
	sbc	#0004h
	sta	RAM_100+2ah

	sep	#20h

	rts



;/////////////////////////////////////////////////////////////////////////;
.segment "DATA00"
;/////////////////////////////////////////////////////////////////////////;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
BG1_COLOR:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$00,$00,$01,$01,$02,$02,$03,$03
	.byte	$04,$04,$05,$05,$06,$06,$07,$07
	.byte	$08,$08,$09,$09,$0a,$0a,$0b,$0b
	.byte	$0c,$0c,$0d,$0d,$0e,$0e,$0f,$0f
	.byte	$10,$10,$11,$11,$12,$12,$13,$13
	.byte	$14,$14,$15,$15,$16,$16,$17,$17
	.byte	$18,$18,$19,$19,$1a,$1a,$1b,$1b
	.byte	$1c,$1c,$1d,$1d,$1e,$1e,$1f,$1f
	.byte	$1f,$1f,$1e,$1e,$1d,$1d,$1c,$1c
	.byte	$1b,$1b,$1a,$1a,$19,$19,$18,$18
	.byte	$17,$17,$16,$16,$15,$15,$14,$14
	.byte	$13,$13,$12,$12,$11,$11,$10,$10
	.byte	$0f,$0f,$0e,$0e,$0d,$0d,$0c,$0c
	.byte	$0b,$0b,$0a,$0a,$09,$09,$08,$08
	.byte	$07,$07,$06,$06,$05,$05,$04,$04
	.byte	$03,$03,$02,$02,$01,$01,$00,$00
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
BG13HOFS_SINE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$1616,$1817,$1a19,$1b1a,$1d1c,$1e1d,$201f,$2120
	.word	$2222,$2423,$2524,$2626,$2727,$2828,$2928,$2a29
	.word	$2a2a,$2b2a,$2b2b,$2b2b,$2b2b,$2b2b,$2b2b,$2b2b
	.word	$2b2b,$2a2b,$2a2a,$2929,$2829,$2728,$2627,$2526
	.word	$2425,$2323,$2122,$2021,$1f1f,$1d1e,$1c1c,$1a1b
	.word	$1819,$1718,$1616,$1415,$1314,$1112,$1010,$0e0f
	.word	$0d0d,$0b0c,$0a0b,$0909,$0708,$0607,$0506,$0405
	.word	$0304,$0303,$0202,$0102,$0101,$0101,$0101,$0101
	.word	$0101,$0101,$0101,$0201,$0202,$0302,$0403,$0404
	.word	$0505,$0606,$0807,$0908,$0a0a,$0c0b,$0d0c,$0f0e
	.word	$100f,$1211,$1312,$1514,$1616,$1716,$1918,$1a1a
	.word	$1c1b,$1d1d,$1f1e,$2020,$2221,$2322,$2424,$2625
	.word	$2726,$2827,$2828,$2929,$2a2a,$2a2a,$2b2b,$2b2b
	.word	$2b2b,$2b2b,$2b2b,$2b2b,$2b2b,$2b2b,$2a2a,$292a
	.word	$2929,$2828,$2727,$2626,$2525,$2324,$2223,$2121
	.word	$1f20,$1e1f,$1c1d,$1b1c,$191a,$1818,$1617,$1516
	.word	$1414,$1213,$1011,$0f10,$0d0e,$0c0d,$0b0b,$090a
	.word	$0809,$0707,$0606,$0505,$0404,$0303,$0203,$0202
	.word	$0101,$0101,$0101,$0101,$0101,$0101,$0101,$0101
	.word	$0202,$0202,$0303,$0404,$0504,$0605,$0706,$0808
	.word	$0a09,$0b0a,$0c0c,$0e0d,$0f0f,$1110,$1212,$1413
	.word	$1615,$1616,$1817,$1a19,$1b1a,$1d1c,$1e1d,$201f
	.word	$2120,$2222,$2423,$2524,$2626,$2727,$2828,$2928
	.word	$2a29,$2a2a,$2b2a,$2b2b,$2b2b,$2b2b,$2b2b,$2b2b
	.word	$2b2b,$2b2b,$2a2b,$2a2a,$2929,$2829,$2728,$2627
	.word	$2526,$2425,$2323,$2122,$2021,$1f1f,$1d1e,$1c1c
	.word	$1a1b,$1819,$1718,$1616,$1415,$1314,$1112,$1010
	.word	$0e0f,$0d0d,$0b0c,$0a0b,$0909,$0708,$0607,$0506
	.word	$0405,$0304,$0303,$0202,$0102,$0101,$0101,$0101
	.word	$0101,$0101,$0101,$0101,$0201,$0202,$0302,$0403
	.word	$0404,$0505,$0606,$0807,$0908,$0a0a,$0c0b,$0d0c
	.word	$0f0e,$100f,$1211,$1312,$1514,$1716
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
BG2_LINES:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$03,$02,$03,$02,$03,$02,$03,$02
	.byte	$03,$02,$02,$02,$02,$02,$01,$02
	.byte	$01,$01,$01,$01,$01,$01,$00,$00
	.byte	$01,$01,$00,$00,$01,$01,$01,$01
	.byte	$01,$01,$02,$01,$02,$02,$02,$02
	.byte	$02,$03,$02,$03,$02,$03,$02,$03
	.byte	$03,$02,$03,$02,$03,$02,$03,$02
	.byte	$03,$02,$02,$02,$02,$02,$01,$02
	.byte	$01,$01,$01,$01,$01,$01,$00,$00
	.byte	$01,$01,$00,$00,$01,$01,$01,$01
	.byte	$01,$01,$02,$01,$02,$02,$02,$02
	.byte	$02,$03,$02,$03,$02,$03,$02,$03
	.byte	$03,$02,$03,$02,$03,$02,$03,$02
	.byte	$03,$02,$02,$02,$02,$02,$01,$02
	.byte	$01,$01,$01,$01,$01,$01,$00,$00
	.byte	$01,$01,$00,$00,$01,$01,$01,$01
	.byte	$01,$01,$02,$01,$02,$02,$02,$02
	.byte	$02,$03,$02,$03,$02,$03,$02,$03
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
CENTER:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$9f,$9f,$9f,$9f,$af,$af,$af,$af
	.byte	$bf,$bf,$bf,$bf,$cf,$cf,$cf,$cf
	.byte	$df,$df,$df,$df,$ef,$ef,$ef,$ef
	.byte	$ff,$ff,$ff,$ff,$0f,$0f,$0f,$0f
	.byte	$1f,$1f,$1f,$1f,$2f,$2f,$2f,$2f
	.byte	$3f,$3f,$3f,$3f,$4f,$4f,$4f,$4f
	.byte	$5f,$5f,$5f,$5f,$6f,$6f,$6f,$6f
	.byte	$7f,$7f,$7f,$7f,$8f,$8f,$8f,$8f
	.byte	$8f,$8f,$8f,$9f,$9f,$9f,$9f
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_BG1MAP:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$00c8,$00cb,$00ce,$00d2,$00d5,$00d9,$00dc,$00e0
	.word	$00e3,$00e7,$00ea,$00ee,$00f1,$00f5,$00f8,$00fb
	.word	$00ff,$0102,$0105,$0109,$010c,$010f,$0113,$0116
	.word	$0119,$011c,$011f,$0123,$0126,$0129,$012c,$012f
	.word	$0132,$0135,$0138,$013a,$013d,$0140,$0143,$0146
	.word	$0148,$014b,$014e,$0150,$0153,$0155,$0158,$015a
	.word	$015c,$015f,$0161,$0163,$0165,$0168,$016a,$016c
	.word	$016e,$0170,$0171,$0173,$0175,$0177,$0178,$017a
	.word	$017c,$017d,$017e,$0180,$0181,$0182,$0184,$0185
	.word	$0186,$0187,$0188,$0189,$018a,$018b,$018b,$018c
	.word	$018d,$018d,$018e,$018e,$018e,$018f,$018f,$018f
	.word	$018f,$018f,$018f,$018f,$018f,$018f,$018f,$018f
	.word	$018e,$018e,$018d,$018d,$018c,$018c,$018b,$018a
	.word	$0189,$0188,$0187,$0186,$0185,$0184,$0183,$0182
	.word	$0181,$017f,$017e,$017c,$017b,$0179,$0178,$0176
	.word	$0174,$0172,$0170,$016f,$016d,$016b,$0169,$0166
	.word	$0164,$0162,$0160,$015e,$015b,$0159,$0156,$0154
	.word	$0151,$014f,$014c,$014a,$0147,$0144,$0142,$013f
	.word	$013c,$0139,$0136,$0133,$0130,$012d,$012a,$0127
	.word	$0124,$0121,$011e,$011b,$0117,$0114,$0111,$010e
	.word	$010a,$0107,$0104,$0100,$00fd,$00fa,$00f6,$00f3
	.word	$00ef,$00ec,$00e9,$00e5,$00e2,$00de,$00db,$00d7
	.word	$00d4,$00d0,$00cd,$00c9,$00c7,$00c3,$00c0,$00bc
	.word	$00b9,$00b5,$00b2,$00ae,$00ab,$00a7,$00a4,$00a1
	.word	$009d,$009a,$0096,$0093,$0090,$008c,$0089,$0086
	.word	$0082,$007f,$007c,$0079,$0075,$0072,$006f,$006c
	.word	$0069,$0066,$0063,$0060,$005d,$005a,$0057,$0054
	.word	$0051,$004e,$004c,$0049,$0046,$0044,$0041,$003f
	.word	$003c,$003a,$0037,$0035,$0032,$0030,$002e,$002c
	.word	$002a,$0027,$0025,$0023,$0021,$0020,$001e,$001c
	.word	$001a,$0018,$0017,$0015,$0014,$0012,$0011,$000f
	.word	$000e,$000d,$000c,$000b,$000a,$ab09,$0008,$0007
	.word	$0006,$0005,$0004,$0004,$0003,$0003,$0002,$0002
	.word	$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001
	.word	$0001,$0001,$0001,$0001,$0002,$0002,$0002,$0003
	.word	$0003,$0004,$0005,$0005,$0006,$0007,$0008,$0009
	.word	$000a,$000b,$000c,$000e,$000f,$0010,$0012,$0013
	.word	$0014,$0016,$0018,$0019,$001b,$001d,$001f,$0020
	.word	$0022,$0024,$0026,$0028,$002b,$002d,$002f,$0031
	.word	$0034,$0036,$0038,$003b,$003d,$0040,$0042,$0045
	.word	$0048,$004a,$004d,$0050,$0053,$0055,$0058,$005b
	.word	$005e,$0061,$0064,$0067,$006a,$006d,$0071,$0074
	.word	$0077,$007a,$007d,$0081,$0084,$0087,$008b,$008e
	.word	$0091,$0095,$0098,$009b,$009f,$00a2,$00a6,$00a9
	.word	$00ad,$00b0,$00b4,$00b7,$00ba,$00be,$00c1,$00c5
	.word	$00c8,$00cb,$00ce,$00d2,$00d5,$00d9,$00dc,$00e0
	.word	$00e3,$00e7,$00ea,$00ee,$00f1,$00f5,$00f8,$00fb
	.word	$00ff,$0102,$0105,$0109,$010c,$010f,$0113,$0116
	.word	$0119,$011c,$011f,$0123,$0126,$0129,$012c,$012f
	.word	$0132,$0135,$0138,$013a,$013d,$0140,$0143,$0146
	.word	$0148,$014b,$014e,$0150,$0153,$0155,$0158,$015a
	.word	$015c,$015f,$0161,$0163,$0165,$0168,$016a,$016c
	.word	$016e,$0170,$0171,$0173,$0175,$0177,$0178,$017a
	.word	$017c,$017d,$017e,$0180,$0181,$0182,$0184,$0185
	.word	$0186,$0187,$0188,$0189,$018a,$018b,$018b,$018c
	.word	$018d,$018d,$018e,$018e,$018e,$018f,$018f,$018f
	.word	$018f,$018f,$018f,$018f,$018f,$018f,$018f,$018f
	.word	$018e,$018e,$018d,$018d,$018c,$018c,$018b,$018a
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_BG12NBA:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	PLASMA_HEIGHT,LOGOGFX>>8+BG1GFX>>12
	.byte	CENTER_HEIGHT,BG4GFX>>8+BG1GFX>>12
	.byte	01h,SCROLLGFX>>8+BG1GFX>>12
	.byte	0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_BG13HOFS:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$0041,$0042,$0044,$0046,$0047,$0049,$004b,$004d
	.word	$004e,$0050,$0052,$0053,$0055,$0057,$0058,$005a
	.word	$005b,$005d,$005f,$0060,$0062,$0063,$0065,$0066
	.word	$0067,$0069,$006a,$006b,$006d,$006e,$006f,$0070
	.word	$0072,$0073,$0074,$0075,$0076,$0077,$0078,$0079
	.word	$007a,$007a,$007b,$007c,$007d,$007d,$007e,$007e
	.word	$007f,$007f,$0080,$0080,$0080,$0081,$0081,$0081
	.word	$0081,$0081,$0081,$0081,$0081,$0081,$0081,$0081
	.word	$0081,$0081,$0080,$0080,$0080,$007f,$007f,$007e
	.word	$007d,$007d,$007c,$007b,$007b,$007a,$0079,$0078
	.word	$0077,$0076,$0075,$0074,$0073,$0072,$0071,$0070
	.word	$006f,$006d,$006c,$006b,$0069,$0068,$0067,$0065
	.word	$0064,$0062,$0061,$005f,$005e,$005c,$005b,$0059
	.word	$0057,$0056,$0054,$0053,$0051,$004f,$004d,$004c
	.word	$004a,$0048,$0047,$0045,$0043,$0041,$0041,$003f
	.word	$003d,$003b,$003a,$0038,$0036,$0035,$0033,$0031
	.word	$002f,$002e,$002c,$002b,$0029,$0027,$0026,$0024
	.word	$0023,$0021,$0020,$001e,$001d,$001b,$001a,$0019
	.word	$0017,$0016,$0015,$0013,$0012,$0011,$0010,$000f
	.word	$000e,$000d,$000c,$000b,$000a,$0009,$0008,$0007
	.word	$0007,$0006,$0005,$0005,$0004,$0003,$0003,$0002
	.word	$0002,$0002,$0001,$0001,$0001,$0001,$0001,$0001
	.word	$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0002
	.word	$0002,$0002,$0003,$0003,$0004,$0004,$0005,$0005
	.word	$0006,$0007,$0008,$0008,$0009,$000a,$000b,$000c
	.word	$000d,$000e,$000f,$0010,$0012,$0013,$0014,$0015
	.word	$0017,$0018,$0019,$001b,$001c,$001d,$001f,$0020
	.word	$0022,$0023,$0025,$0027,$0028,$002a,$002b,$002d
	.word	$002f,$0030,$0032,$0034,$0035,$0037,$0039,$003b
	.word	$003c,$003e,$0040,$0041,$0042,$0044,$0046,$0047
	.word	$0049,$004b,$004d,$004e,$0050,$0052,$0053,$0055
	.word	$0057,$0058,$005a,$005b,$005d,$005f,$0060,$0062
	.word	$0063,$0065,$0066,$0067,$0069,$006a,$006b,$006d
	.word	$006e,$006f,$0070,$0072,$0073,$0074,$0075,$0076
	.word	$0077,$0078,$0079,$007a,$007a,$007b,$007c,$007d
	.word	$007d,$007e,$007e,$007f,$007f,$0080,$0080,$0080
	.word	$0081,$0081,$0081,$0081,$0081,$0081,$0081,$0081
	.word	$0081,$0081,$0081,$0081,$0081,$0080,$0080,$0080
	.word	$007f,$007f,$007e,$007d,$007d,$007c,$007b,$007b
	.word	$007a,$0079,$0078,$0077,$0076,$0075,$0074,$0073
	.word	$0072,$0071,$0070,$006f,$006d,$006c,$006b,$0069
	.word	$0068,$0067,$0065,$0064,$0062,$0061,$005f,$005e
	.word	$005c,$005b,$0059,$0057,$0056,$0054,$0053,$0051
	.word	$004f,$004d,$004c,$004a,$0048,$0047,$0045,$0043
	.word	$0041,$0041,$003f,$003d,$003b,$003a,$0038,$0036
	.word	$0035,$0033,$0031,$002f,$002e,$002c,$002b,$0029
	.word	$0027,$0026,$0024,$0023,$0021,$0020,$001e,$001d
	.word	$001b,$001a,$0019,$0017,$0016,$0015,$0013,$0012
	.word	$0011,$0010,$000f,$000e,$000d,$000c,$000b,$000a
	.word	$0009,$0008,$0007,$0007,$0006,$0005,$0005,$0004
	.word	$0003,$0003,$0002,$0002,$0002,$0001,$0001,$0001
	.word	$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001
	.word	$0001,$0001,$0002,$0002,$0002,$0003,$0003,$0004
	.word	$0004,$0005,$0005,$0006,$0007,$0008,$0008,$0009
	.word	$000a,$000b,$000c,$000d,$000e,$000f,$0010,$0012
	.word	$0013,$0014,$0015,$0017,$0018,$0019,$001b,$001c
	.word	$001d,$001f,$0020,$0022,$0023,$0025,$0027,$0028
	.word	$002a,$002b,$002d,$002f,$0030,$0032,$0034,$0035
	.word	$0037,$0039,$003b,$003c,$003e,$0040,$0041,$0042
	.word	$0044,$0046,$0047,$0049,$004b,$004d,$004e,$0050
	.word	$0052,$0053,$0055,$0057,$0058,$005a,$005b,$005d
	.word	$005f,$0060,$0062,$0063,$0065,$0066,$0067,$0069
	.word	$006a,$006b,$006d,$006e,$006f,$0070,$0072,$0073
	.word	$0074,$0075,$0076,$0077,$0078,$0079,$007a,$007a
	.word	$007b,$007c,$007d,$007d,$007e,$007e,$007f,$007f
	.word	$0080,$0080,$0080,$0081,$0081,$0081,$0081,$0081
	.word	$0081,$0081,$0081,$0081,$0081,$0081,$0081,$0081
	.word	$0080,$0080,$0080,$007f,$007f,$007e,$007d,$007d
	.word	$007c,$007b,$007b,$007a,$0079,$0078,$0077,$0076
	.word	$0075,$0074,$0073,$0072,$0071,$0070,$006f,$006d
	.word	$006c,$006b,$0069,$0068,$0067,$0065,$0064,$0062
	.word	$0061,$005f,$005e,$005c,$005b,$0059,$0057,$0056
	.word	$0054,$0053,$0051,$004f,$004d,$004c,$004a,$0048
	.word	$0047,$0045,$0043,$0041,$0041,$003f,$003d,$003b
	.word	$003a,$0038,$0036,$0035,$0033,$0031,$002f,$002e
	.word	$002c,$002b,$0029,$0027,$0026,$0024,$0023,$0021
	.word	$0020,$001e,$001d,$001b,$001a,$0019,$0017,$0016
	.word	$0015,$0013,$0012,$0011,$0010,$000f,$000e,$000d
	.word	$000c,$000b,$000a,$0009,$0008,$0007,$0007,$0006
	.word	$0005,$0005,$0004,$0003,$0003,$0002,$0002,$0002
	.word	$0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001
	.word	$0001,$0001,$0001,$0001,$0001,$0002,$0002,$0002
	.word	$0003,$0003,$0004,$0004,$0005,$0005,$0006,$0007
	.word	$0008,$0008,$0009,$000a,$000b,$000c,$000d,$000e
	.word	$000f,$0010,$0012,$0013,$0014,$0015,$0017,$0018
	.word	$0019,$001b,$001c,$001d,$001f,$0020,$0022,$0023
	.word	$0025,$0027,$0028,$002a,$002b,$002d,$002f,$0030
	.word	$0032,$0034,$0035,$0037,$0039,$003b,$003c,$003e
	.word	$0040
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_BGSC:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	PLASMA_HEIGHT,LOGOMAP>>8,BG3MAP>>8
	.byte	CENTER_HEIGHT,BG4MAP>>8,NULMAP>>8
	.byte	1,NULMAP>>8,NULMAP>>8
	.byte	1,SCROLLMAP>>8|SC_64x32,NULMAP>>8
	.byte	0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_CGADSUB:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	PLASMA_HEIGHT,%10000010
	.byte	CENTER_HEIGHT,0
	.byte	1,%01000010
	.byte	0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
PAL:	.word	$1ce7,$5294,$6318
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
SCROLLTEXT:	; [ = ,        \ = -        ] = .        ^ = '        _ = :
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	"            SNESMOD STREAMING AUDIO EXAMPLE"
	.byte	"     GREETINGS TO     "
	.byte	"\ BAMIGA SECTOR ONE \ CENSOR \ CRYPTOBURNERS \ DEXION \ ELITENDO \ ESI \ FAIRLIGHT \ FBR \ HONEYMOONS \ HZL \ IKARI \ KEFRENS \ NORTHSTAR \ OKS \ REIN SANCTION \ ROTTEN ROW \ RSI \ THE SILENTS \ SILKWORM \ TRIAD \ WOLFHOUNDS \"
	.byte	"     ",0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
SINE_OF_DOOM:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$80,$83,$86,$89,$8c,$8f,$92,$95
	.byte	$98,$9b,$9e,$a1,$a4,$a7,$aa,$ad
	.byte	$b0,$b3,$b6,$b9,$bc,$be,$c1,$c4
	.byte	$c6,$c9,$cb,$ce,$d0,$d3,$d5,$d7
	.byte	$d9,$dc,$de,$e0,$e2,$e4,$e6,$e8
	.byte	$e9,$eb,$ed,$ee,$f0,$f1,$f2,$f4
	.byte	$f5,$f6,$f7,$f8,$f9,$fa,$fb,$fc
	.byte	$fc,$fd,$fd,$fe,$fe,$fe,$fe,$fe
	.byte	$fe,$fe,$fe,$fe,$fe,$fd,$fd,$fd
	.byte	$fc,$fb,$fb,$fa,$f9,$f8,$f7,$f6
	.byte	$f5,$f3,$f2,$f1,$ef,$ee,$ec,$ea
	.byte	$e9,$e7,$e5,$e3,$e1,$df,$dd,$db
	.byte	$d9,$d6,$d4,$d2,$cf,$cd,$ca,$c8
	.byte	$c5,$c3,$c0,$bd,$bb,$b8,$b5,$b2
	.byte	$af,$ac,$a9,$a6,$a3,$a0,$9d,$9a
	.byte	$97,$94,$91,$8e,$8b,$88,$85,$82
	.byte	$7f,$7c,$79,$76,$73,$70,$6d,$6a
	.byte	$67,$64,$60,$5d,$5b,$58,$55,$52
	.byte	$4f,$4c,$49,$46,$44,$41,$3e,$3b
	.byte	$39,$36,$34,$31,$2f,$2d,$2a,$28
	.byte	$26,$24,$21,$1f,$1d,$1c,$1a,$18
	.byte	$16,$14,$13,$11,$10,$0e,$0d,$0c
	.byte	$0b,$09,$08,$07,$07,$06,$05,$04
	.byte	$04,$03,$03,$02,$02,$02,$02,$02
	.byte	$02,$02,$02,$02,$02,$02,$03,$03
	.byte	$04,$04,$05,$06,$07,$07,$08,$0a
	.byte	$0b,$0c,$0d,$0e,$10,$11,$13,$15
	.byte	$16,$18,$1a,$1c,$1e,$20,$22,$24
	.byte	$26,$28,$2a,$2d,$2f,$31,$34,$36
	.byte	$39,$3c,$3e,$41,$44,$46,$49,$4c
	.byte	$4f,$52,$55,$58,$5b,$5e,$61,$64
	.byte	$67,$6a,$6d,$70,$73,$76,$79,$7c
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;



;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
TEXT:		;123456789012345**890123456789012
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	"                                "
	.byte	"                                "
	.byte	"   FR]N ANDRA SIDAN GRAVEN:     "
	.byte	"          AUGUSTUS BLACKHEART   "
	.byte	"   SOUND DRIVER:                "
	.byte	"                      MUKUNDA   "
	.byte	"   SOUND DRIVER:                "
	.byte	"          AUGUSTUS BLACKHEART   "
	.byte	"   SOUND DRIVER:                "
	.byte	"                  KUNGFUFURBY   "
	.byte	"   PLASMA AND STRETCH EFFECT:   "
	.byte	"              ALFATECH/CENSOR   "
	.byte	"   SNESKIT:                     "
	.byte	"                      MUKUNDA   "
	.byte	"   OTHER CODE:                  "
	.byte	"          AUGUSTUS BLACKHEART   "
	.byte	"                                "
	.byte	"                                "
	.byte	"                                "
	.byte	"                                "
	.byte	"        TV] STARKA RINGNINGAT   "
	.byte	"                    I KLOCKAN   "
	.byte	"                      CIRCLED   "
	.byte	"         THE LAND THREE TIMES   "
	.byte	"             LET LOOSE A HOWL   "
	.byte	"        UPON THE SOLEMN NIGHT   "
	.byte	"                  THEN SLOWLY   "
	.byte	"                         DIED   "
	.byte	"                                "
	.byte	"                                "
	.byte	"   H[R ST]R JAG OCH PRATAR OM   "
	.byte	"               DR\MMAR MED ER   "
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
