;-------------------------------------------------------------------------;
.include "brr.inc"
.include "options.inc"
.include "shadow_ram.inc"
.include "snes.inc"
.include "snes_joypad.inc"
.include "snesmod.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;
.import DoCredits, DoIntro, ClearWorkRAM7E, ClearRAM, ClearVRAM, InitReg
;-------------------------------------------------------------------------;
.global main, FadeMosaic, SuperResetStuff, ResetStuff
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.zeropage
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
options:
	.res	1
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.segment "XCODE"
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;.........................................................................;
; program entry point
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
main:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	jsr	DoIntro
	jsr	spcReset
	jsr	spcFlush
	jsr	ResetStuff

	lda	#7eh
	ldx	#0500h
	ldy	#1affh
	jsr	ClearRAM
	jsr	InitReg
	jsr	ClearVRAM

	brk


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
FadeMosaic:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	options
	bit	#OPTION_FADE_OUT
	bne	FadeOutMosaic
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
FadeInMosaic:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	reg_inidisp
	cmp	#32
	beq	endm
	lsr
;-------------------------------------------------------------------------;
	sta	REG_INIDISP
	inc	reg_inidisp
	xba
	lda	options
	bit	#OPTION_MOSAIC
	beq	endm
;-------------------------------------------------------------------------;
	xba
	asl
	asl
	asl
	asl
	eor	#0f0h
	ora	#%1111
	sta	REG_MOSAIC
;-------------------------------------------------------------------------;
endm:	rts
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
FadeOutMosaic:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	reg_inidisp
	beq	endm
;-------------------------------------------------------------------------;
	dea
	sta	reg_inidisp
	pha
	lsr
	sta	REG_INIDISP

	lda	options
	bit	#OPTION_MOSAIC
	beq	endm2
;-------------------------------------------------------------------------;
	cld
	clc
	lda	reg_mosaic
	adc	#10h
	sta	REG_MOSAIC
	sta	reg_mosaic
endm2:	pla
	rts
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
SuperResetStuff:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	sei

	lda	#80h
	sta	REG_INIDISP
	stz	REG_HDMAEN
	stz	REG_NMITIMEN
	stz	reg_mdmaen

	jsr	ClearVRAM
	jsr	InitReg
	bra	:+
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
ResetStuff:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	#80h
	sta	REG_INIDISP
	stz	REG_HDMAEN
	stz	REG_NMITIMEN
	stz	reg_mdmaen

:	jsr	ClearWorkRAM7E

	lda	#OPTION_FRAME_READY|OPTION_FADE_OUT|OPTION_VWF_UPDATE
	trb	options

	stz	brr_end
	stz	brr_index
	stz	brr_index+1
	stz	reg_hdmaen
	stz	reg_inidisp
	stz	song_cmp
	stz	song_cmp+1

	lda	#02h
	sta	REG_CGSWSEL

	ldx	#16
;-------------------------------------------------------------------------;
:	stz	m0,x
	dex
	bpl	:-
;-------------------------------------------------------------------------;
	ldx	#00fffh
:	stz	0000h,x
	dex
	cpx	#0500h
	bcs	:-

	lda	#0ffh
	sta	REG_BG1VOFS
	stz	REG_BG1VOFS
	sta	REG_BG2VOFS
	stz	REG_BG2VOFS
	sta	REG_BG3VOFS
	stz	REG_BG3VOFS

	rts



;/////////////////////////////////////////////////////////////////////////;
.segment "HDATA"
;/////////////////////////////////////////////////////////////////////////;
.segment "HRAM2"
;/////////////////////////////////////////////////////////////////////////;
