;-------------------------------------------------------------------------;
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_zvars.inc"
.include "snes_joypad.inc"
.include "graphics.inc"
;-------------------------------------------------------------------------;
.export DoTranslucent
;-------------------------------------------------------------------------;


; artwork by ansimuz
; https://opengameart.org/users/ansimuz
; http://www.patreon.com/ansimuz
; https://creativecommons.org/publicdomain/zero/1.0/


;-------------------------------------------------------------------------;
BG1GFX = 4000h
BG1MAP = 0400h
BG2GFX = 0800h
BG2MAP = 0000h
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
reg_bg2hofs = m4
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
	.code
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
DoTranslucent:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

	; gfx_clouds.grit should contain -ma2176 since it uses the 3rd
	; palette and the offset is 0x800

	DoDecompressDataVram gfx_modtilesetMap, BG1MAP*2
	DoDecompressDataVram gfx_modtilesetTiles, BG1GFX*2
	DoCopyPalette gfx_modtilesetPal, 0, 32
	DoCopyPalette gfx_cloudsPal, 32, 8
	DoDecompressDataVram gfx_cloudsMap, BG2MAP*2
	DoDecompressDataVram gfx_cloudsTiles, BG2GFX*2

	lda	#BG1MAP>>8
	sta	REG_BG1SC

	lda	#BG2MAP>>8
	sta	REG_BG2SC

	lda	#BG2GFX>>8+BG1GFX>>12
	sta	REG_BG12NBA

	stz	REG_BG1HOFS
	stz	REG_BG1HOFS
	stz	REG_BG2HOFS
	stz	REG_BG2HOFS

	lda	#0ffh
	sta	REG_BG1VOFS
	stz	REG_BG1VOFS
	sta	REG_BG2VOFS
	stz	REG_BG2VOFS

	lda	#TM_BG1
	sta	REG_TM

	ina
	sta	REG_TS

	;lda	#02h
	sta	REG_CGSWSEL
	ina
	;lda	#BGMODE_3
	sta	REG_BGMODE

	lda	#%01100001
	sta	REG_CGADSUB

	lda	#0e0h
	sta	REG_COLDATA

	lda	#0fh
	sta	REG_INIDISP
;-------------------------------------------------------------------------;
:
;-------------------------------------------------------------------------;
	lda	REG_RDNMI
	bpl	:-

	rep	#30h

	inc	reg_bg2hofs
	lda	reg_bg2hofs

	sep	#20h

	sta	REG_BG2HOFS

	xba
	and	#%11
	sta	REG_BG2HOFS
;-------------------------------------------------------------------------;
	bra     :-
