
;---------------------------;
; SNES Register Definitions ;
;---------------------------;

.ifndef __SNES_INC__
__SNES_INC__ = 1

REG_INIDISP		:= 2100h	; Screen Display Register		1B/W
REG_OBSEL		:= 2101h	; OAM Size Control			1B/W
REG_OBJSEL		:= 2101h	; OAM Size Control			1B/W [official name]
REG_OAMADD		:= 2102h	; OAM Access Address			2B/W
REG_OAMADDL		:= 2102h	;
REG_OAMADDH		:= 2103h	;
REG_OAMDATA		:= 2104h	; OAM Data Write			1B/W
REG_BGMODE		:= 2105h	; Screen Mode Register			1B/W
REG_MOSAIC		:= 2106h	; Screen Pixelation Register		1B/W
REG_BG1SC		:= 2107h	; BG1 VRAM Location Register		1B/W
REG_BG2SC		:= 2108h	; BG2 VRAM Location Register		1B/W
REG_BG3SC		:= 2109h	; BG3 VRAM Location Register		1B/W
REG_BG4SC		:= 210Ah	; BG4 VRAM Location Register		1B/W
REG_BG12NBA		:= 210Bh	; BG1/2 Character Bases			1B/W
REG_BG34NBA		:= 210Ch	; BG3/4 Character Bases			1B/W
REG_BG1HOFS		:= 210Dh	; BG1 Horizontal Scroll			1B/W D
REG_BG1VOFS		:= 210Eh	; BG1 Vertical Scroll			1B/W D
REG_BG2HOFS		:= 210Fh	; BG2 Horizontal Scroll			1B/W D
REG_BG2VOFS		:= 2110h	; BG2 Vertical Scroll			1B/W D
REG_BG3HOFS		:= 2111h	; BG3 Horizontal Scroll			1B/W D
REG_BG3VOFS		:= 2112h	; BG3 Vertical Scroll			1B/W D
REG_BG4HOFS		:= 2113h	; BG4 Horiztonal Scroll			1B/W D
REG_BG4VOFS		:= 2114h	; BG4 Vertical Scroll			1B/W D
REG_VMAIN		:= 2115h	; Video Port Control			1B/W
REG_VMAINC		:= 2115h	; Video Port Control			1B/W [official name]
REG_VMADD		:= 2116h	; Video Port Address			2B/W
REG_VMADDL		:= 2116h	;
REG_VMADDH		:= 2117h	;
REG_VMDATA		:= 2118h	; Video Port Data			2B/W
REG_VMDATAL		:= 2118h	;
REG_VMDATAH		:= 2119h	;
REG_M7SEL		:= 211Ah	; MODE7 settings register		1B/W
REG_M7A			:= 211Bh	; MODE7 COSINE A			1B/W
REG_M7B			:= 211Ch	; MODE7 SINE	A			1B/W
REG_M7C			:= 211Dh	; MODE7 SINE	B			1B/W
REG_M7D			:= 211Eh	; MODE7 COSINE B			1B/W
REG_M7X			:= 211Fh	; MODE7 Center Pos X			1B/W D
REG_M7Y			:= 2120h	; MODE7 Center Pos Y			1B/W D
REG_CGADD		:= 2121h	; CGRAM Address				1B/W
REG_CGDATA		:= 2122h	; CGRAM Data Write			1B/W D
REG_W12SEL		:= 2123h	; Window Mask Settings Reg1		1B/W
REG_W34SEL		:= 2124h	; Window Mask Settings Reg2		1B/W
REG_WOBJSEL		:= 2125h	; Window Mask Settings Reg3		1B/W
REG_WH0			:= 2126h	; Window 1 Left Posision Reg		1B/W
REG_WH1			:= 2127h	; Window 1 Right Position Reg		1B/W
REG_WH2			:= 2128h	; Window 2 Left Position Reg		1B/W
REG_WH3			:= 2129h	; Window 2 Right Position Reg		1B/W
REG_WBGLOG		:= 212Ah	; Mask Logic for Window 1 & 2		1B/W
REG_WOBJLOG		:= 212Bh	; Mask Logic for Color&OBJ Windows	1B/W
REG_TM			:= 212Ch	; Main Screen Designation		1B/W
REG_TS			:= 212Dh	; Sub-Screen Designation		1B/W
REG_TMW			:= 212Eh	; WinMask Main Designation Reg		1B/W
REG_TSW			:= 212Fh	; WinMask Sub Designation Reg		1B/W
REG_CGSWSEL		:= 2130h	; Fixed Color/Screen Addition Reg	1B/W
REG_CGADSUB		:= 2131h	; +/- For Screens/BGs/OBJs		1B/W
REG_COLDATA		:= 2132h	; Fixed Color Data for +/-		1B/W
REG_SETINI		:= 2133h	; Screen Mode Select Reg		1B/W
REG_MPYL		:= 2134h	; Multiplication Result Low		1B/R
REG_MPYM		:= 2135h	; Middle				1B/R
REG_MPYH		:= 2136h	; High					1B/R
REG_SLHV		:= 2137h	; Sofware Latch For H/V Counter		1B/R
REG_OAMDATAREAD		:= 2138h	; OAM Data Read				1B/R
REG_VMDATAREAD		:= 2139h	; VRAM Data Read 			1B/R
REG_VMDATALREAD		:= 2139h	; VRAM Data Read Low			1B/R
REG_VMDATAHREAD		:= 213Ah	; VRAM Data Read High			1B/R
REG_CGDATAREAD		:= 213Bh	; CGRAM Data Read			1B/R
REG_OPHCT		:= 213Ch	; X Scanline Location			1B/R D
REG_OPVCT		:= 213Dh	; Y Scanline Location			1B/R D
REG_STAT77		:= 213Eh	; PPU Status Flag & Version		1B/R
REG_STAT78		:= 213Fh	; PPU Status Flag & Version		1B/R
REG_APUIO0		:= 2140h	; Sound Register			1B/RW
REG_APUIO1		:= 2141h	; Sound Register			1B/RW
REG_APUIO2		:= 2142h	; Sound Register			1B/RW
REG_APUIO3		:= 2143h	; Sound Register			1B/RW
REG_WMDATA		:= 2180h	; WRAM Data Read/Write			1B/RW
REG_WMADDL		:= 2181h	; WRAM Address (Low)			1B/RW
REG_WMADDM		:= 2182h	; WRAM Address (Middle)			1B/RW
REG_WMADDH		:= 2183h	; WRAM Address (High)			1B/RW

REG_NMITIMEN		:= 4200h	; Counter Enable			1B/W
REG_WRIO		:= 4201h	; Programmable I/O Port			1B/W
REG_WRMPYA		:= 4202h	; Multiplicand				1B/W
REG_WRMPYB		:= 4203h	; Multiplier				1B/W
REG_WRDIVL		:= 4204h	; Dividend				2B/W ???
REG_WRDIVH		:= 4205h	;					???
REG_WRDIVB		:= 4206h	; Divisor				???
REG_HTIMEL		:= 4207h	; Video X IRQ Beam Pointer		2B/W
REG_HTIMEH		:= 4208h	;
REG_VTIMEL		:= 4209h	; Video Y IRQ Beam Pointer		2B/W
REG_VTIMEH		:= 420Ah	;
REG_MDMAEN		:= 420Bh	; DMA Enable Register			1B/W
REG_HDMAEN		:= 420Ch	; HDMA Enable Register			1B/W
REG_MEMSEL		:= 420Dh	; Cycle Speed Register			1B/W
REG_RDNMI		:= 4210h	; NMI Register				1B/R
REG_TIMEUP		:= 4211h	; Video IRQ Register			1B/RW
REG_HVBJOY		:= 4212h	; Status Register			1B/RW
REG_RDIO		:= 4213h	; Programmable I/O Port			1B/RW
REG_RDDIVL		:= 4214h	; Quotient Of Divide Result		2B/R
REG_RDDIVH		:= 4215h	;
REG_RDMPYL		:= 4216h	; Multiplication Or Divide Result	2B/R
REG_RDMPYH		:= 4217h	;
REG_JOY1L		:= 4218h	; Joypad #1 Status			2B/R
REG_JOY1H		:= 4219h	;
REG_JOY2L		:= 421Ah	; Joypad #2 Status			2B/R
REG_JOY2H		:= 421Bh	;
REG_JOY3L		:= 421Ch	; Joypad #3 Status			2B/R
REG_JOY3H		:= 421Dh	;
REG_JOY4L		:= 421Eh	; Joypad #4 Status			2B/R
REG_JOY4H		:= 421Fh	;

REG_DMAP0		:= 4300h	; DMA Control Register			1B/W
REG_BBAD0		:= 4301h	; DMA Destination Register		1B/W
REG_A1T0		:= 4302h	; DMA Source Address			2B/W
REG_A1T0L		:= 4302h	;
REG_A1T0H		:= 4303h	;
REG_A1B0		:= 4304h	; Source Bank Address			1B/W
REG_DAS0		:= 4305h	; DMA Transfer size/HDMA Address	2B/W
REG_DAS0L		:= 4305h	; Indirect HDMA Addr/DMA current addr
REG_DAS0H		:= 4306h	;
REG_DASB0		:= 4307h	;
REG_A2T0L		:= 4308h	; HDMA table current address
REG_A2T0H		:= 4309h	;
REG_NLTR0		:= 430Ah	; Number Of Lines For HDMA		1B/W
REG_DMAP1		:= 4310h	; DMA 1
REG_BBAD1		:= 4311h	;
REG_A1T1		:= 4312h	;
REG_A1T1L		:= 4312h	;
REG_A1T1H		:= 4313h	;
REG_A1B1		:= 4314h	;
REG_DAS1		:= 4315h	;
REG_DAS1L		:= 4315h	;
REG_DAS1H		:= 4316h	;
REG_DASB1		:= 4317h	;
REG_A2T1L		:= 4318h	;
REG_A2T1H		:= 4319h	;
REG_NLTR1		:= 431Ah	;
REG_DMAP2		:= 4320h	; DMA 2
REG_BBAD2		:= 4321h	;
REG_A1T2		:= 4322h	;
REG_A1T2L		:= 4322h	;
REG_A1T2H		:= 4323h	;
REG_A1B2		:= 4324h	;
REG_DAS2		:= 4325h	;
REG_DAS2L		:= 4325h	;
REG_DAS2H		:= 4326h	;
REG_DASB2		:= 4327h	;
REG_A2T2L		:= 4328h	;
REG_A2T2H		:= 4329h	;
REG_NLTR2		:= 432Ah	;
REG_DMAP3		:= 4330h	; DMA 3
REG_BBAD3		:= 4331h	;
REG_A1T3		:= 4332h	;
REG_A1T3L		:= 4332h	;
REG_A1T3H		:= 4333h	;
REG_A1B3		:= 4334h	;
REG_DAS3		:= 4335h	;
REG_DAS3L		:= 4335h	;
REG_DAS3H		:= 4336h	;
REG_DASB3		:= 4337h	;
REG_A2T3L		:= 4338h	;
REG_A2T3H		:= 4339h	;
REG_NLTR3		:= 433Ah	;
REG_DMAP4		:= 4340h	; DMA 4
REG_BBAD4		:= 4341h	;
REG_A1T4		:= 4342h	;
REG_A1T4L		:= 4342h	;
REG_A1T4H		:= 4343h	;
REG_A1B4		:= 4344h	;
REG_DAS4		:= 4345h	;
REG_DAS4L		:= 4345h	;
REG_DAS4H		:= 4346h	;
REG_DASB4		:= 4347h	;
REG_A2T4L		:= 4348h	;
REG_A2T4H		:= 4349h	;
REG_NLTR4		:= 434Ah	;
REG_DMAP5		:= 4350h	; DMA 5
REG_BBAD5		:= 4351h	;
REG_A1T5		:= 4352h	;
REG_A1T5L		:= 4352h	;
REG_A1T5H		:= 4353h	;
REG_A1B5		:= 4354h	;
REG_DAS5		:= 4355h	;
REG_DAS5L		:= 4355h	;
REG_DAS5H		:= 4356h	;
REG_DASB5		:= 4357h	;
REG_A2T5L		:= 4358h	;
REG_A2T5H		:= 4359h	;
REG_NLTR5		:= 435Ah	;
REG_DMAP6		:= 4360h	; DMA 6
REG_BBAD6		:= 4361h	;
REG_A1T6		:= 4362h	;
REG_A1T6L		:= 4362h	;
REG_A1T6H		:= 4363h	;
REG_A1B6		:= 4364h	;
REG_DAS6		:= 4365h	;
REG_DAS6L		:= 4365h	;
REG_DAS6H		:= 4366h	;
REG_DASB6		:= 4367h	;
REG_A2T6L		:= 4368h	;
REG_A2T6H		:= 4369h	;
REG_NLTR6		:= 436Ah	;
REG_DMAP7		:= 4370h	; DMA 7
REG_BBAD7		:= 4371h	;
REG_A1T7		:= 4372h	;
REG_A1T7L		:= 4372h	;
REG_A1T7H		:= 4373h	;
REG_A1B7		:= 4374h	;
REG_DAS7		:= 4375h	;
REG_DAS7L		:= 4375h	;
REG_DAS7H		:= 4376h	;
REG_DASB7		:= 4377h	;
REG_A2T7L		:= 4378h	;
REG_A2T7H		:= 4379h	;
REG_NLTR7		:= 437Ah	;
REG_FBNANACNT		:= 0FEEDh	; Felon's Banana Register		1B/RW

BG_PRIO			= 20h
BG3_PRIO		= BG_PRIO
BGMODE_0		= 00h
BGMODE_1		= 01h
BGMODE_2		= 02h
BGMODE_3		= 03h
BGMODE_4		= 04h
BGMODE_5		= 05h
BGMODE_6		= 06h
BGMODE_7		= 07h
BGMODE_PRIO		= 08h
BGMODE_16x16_1		= 10h
BGMODE_16x16_2		= 20h
BGMODE_16x16_3		= 40h
BGMODE_16x16_4		= 80h

CGADSUB_BG1		= 01h
CGADSUB_BG2		= 02h
CGADSUB_BG3		= 04h
CGADSUB_BG4		= 08h
CGADSUB_OBJ		= 10h
CGADSUB_BACKDROP	= 20h
CGADSUB_HALFCOLOR	= 40h
CGADSUB_SUBTRACT	= 80h

CGADSUB_BACK		= CGADSUB_BACKDROP
CGADSUB_BCK		= CGADSUB_BACKDROP
CGADSUB_HALF		= CGADSUB_HALFCOLOR
CGADSUB_SUB		= CGADSUB_SUBTRACT

TM_BG1			= CGADSUB_BG1
TM_BG2			= CGADSUB_BG2
TM_BG3			= CGADSUB_BG3
TM_BG4			= CGADSUB_BG4
TM_OBJ			= CGADSUB_OBJ

TMW_BG1			= CGADSUB_BG1
TMW_BG2			= CGADSUB_BG2
TMW_BG3			= CGADSUB_BG3
TMW_BG4			= CGADSUB_BG4
TMW_OBJ			= CGADSUB_OBJ

TSW_BG1			= CGADSUB_BG1
TSW_BG2			= CGADSUB_BG2
TSW_BG3			= CGADSUB_BG3
TSW_BG4			= CGADSUB_BG4
TSW_OBJ			= CGADSUB_OBJ

DMAP_XFER_MODE_0	= 00h
DMAP_XFER_MODE_1	= 01h
DMAP_XFER_MODE_2	= 02h
DMAP_XFER_MODE_3	= 03h
DMAP_XFER_MODE_4	= 04h
DMAP_XFER_MODE_5	= 05h
DMAP_XFER_MODE_6	= 06h
DMAP_XFER_MODE_7	= 07h
DMAP_FIXED		= 08h
DMAP_DECREMENT		= 10h
DMAP_POINTERS		= 40h
DMAP_PPU_TO_CPU		= 80h

INI_SCREEN_INTERLACE	= 01h
INI_OBJ_INTERLACE	= 02h
INI_OVERSCAN		= 04h
INI_PSEUDO_HIRES	= 08h
INI_BG2			= 40h
INI_EXT_SYNC		= 80h

JOYPAD_R		= 10h
JOYPAD_L		= 20h
JOYPAD_X		= 40h
JOYPAD_A		= 80h

JOYPAD_RIGHT		= 100h
JOYPADH_RIGHT		= 1h
JOYPAD_LEFT		= 200h
JOYPADH_LEFT		= 2h
JOYPAD_DOWN		= 400h
JOYPADH_DOWN		= 4h
JOYPAD_UP		= 800h
JOYPADH_UP		= 8h
JOYPAD_START		= 1000h
JOYPADH_START		= 10h
JOYPAD_SELECT		= 2000h
JOYPADH_SELECT		= 20h
JOYPAD_Y		= 4000h
JOYPADH_Y		= 40h
JOYPAD_B		= 8000h
JOYPADH_B		= 80h

M7SEL_HMIRROR		= 01h
M7SEL_VMIRROR		= 02h
M7SEL_CHAR0		= 40h
M7SEL_REPEAT		= 80h

NMI_JOYPAD		= %00000001
NMI_IRQX		= %00010000
NMI_IRQY		= %00100000
NMI_ON			= %10000000

OBSEL_8_16		= %00000000
OBSEL_8_32		= %00100000
OBSEL_8_64		= %01000000
OBSEL_16_32		= %01100000
OBSEL_16_64		= %10000000
OBSEL_32_64		= %10100000
OBSEL_16x32_32x64	= %11000000
OBSEL_16x32_32x32	= %11100000
OBSEL_08_16		= OBSEL_8_16
OBSEL_08_32		= OBSEL_8_32
OBSEL_08_64		= OBSEL_8_64
OBSEL_NN_16K		= %00011000
OBSEL_NN_12K		= %00010000
OBSEL_NN_8K		= %00001000
OBSEL_NN_08K		= OBSEL_NN_8K
.define OBSEL_BASE(bbb)	(((bbb)>>14))

OAM_NT0			= %00000000
OAM_NT1			= %00000001

OAM_PAL0		= %00000000
OAM_PAL1		= %00000010
OAM_PAL2		= %00000100
OAM_PAL3		= %00000110
OAM_PAL4		= %00001000
OAM_PAL5		= %00001010
OAM_PAL6		= %00001100
OAM_PAL7		= %00001110

OAM_PRI0		= %00000000
OAM_PRI1		= %00010000
OAM_PRI2		= %00100000
OAM_PRI3		= %00110000

OAM_HFLIP		= %01000000
OAM_VFLIP		= %10000000

PALETTE0		= 0<<2
PALETTE1		= 1<<2
PALETTE2		= 2<<2
PALETTE3		= 3<<2
PALETTE4		= 4<<2
PALETTE5		= 5<<2
PALETTE6		= 6<<2
PALETTE7		= 7<<2

SC_32x32		= %00
SC_64x32		= %01
SC_32x64		= %10
SC_64x64		= %11

SETINI_INTV		= %00000001
SETINI_INTOBJ		= %00000010
SETINI_OVERSCAN		= %00000100
SETINI_INTH		= %00001000
SETINI_EXTBG		= %01000000
SETINI_EXTSYNC		= %10000000

SETINI_PSEUDOHIRES	= SETINI_INTH

STAT77_TIME_OVER	= %10000000
STAT77_RANGE_OVER	= %01000000

STAT78_PAL		= %00010000
STAT78_EXT_LATCH	= %01000000
STAT78_INTERLACE	= %10000000

VMAIN_INC1		= %00000000
VMAIN_INC32		= %00000001
VMAIN_INC128X		= %00000010
VMAIN_INC128Y		= %00000011
VMAIN_INCL		= %00000000
VMAIN_INCH		= %10000000

.endif
